/*
This sample program shows how to use the DC_ExecuteSQL() function to create a new
database from an SQL query using the INTO clause.

DC_ExecuteSQL() does not use the ADSDBE or DacSession(). Instead it makes ADS API
calls that are in ACE32.DLL by using the ADS wrapper functions in _DCADS.PRG.

Any ADS SQL statement that does not require a cursor to be returned can be run
with this function.
*/

#INCLUDE "dcdialog.CH"

FUNCTION Main()

LOCAL GetList[0], oBrowse, GetOptions, cServer, cSql, cErrorString, ;
      nCursor := 0

DC_LoadRdds()
DC_ChDir('.\files\data')

FErase('BALANCES.DBF')

TEXT INTO cSql WRAP
SELECT
Invoice.Inv_nmbr as Invoice,
Invoice.Balance as Balance,
Customer.Bill_name as Customer,
Customer.Phone as Phone
INTO Balances
FROM Invoice
LEFT OUTER JOIN Customer ON invoice.cust_nmbr = Customer.cust_nmbr
WHERE Invoice.Balance > 0
ORDER BY balance
ENDTEXT

cServer := 'C:'
cErrorString := ''

DC_ExecuteSQL( cServer, cSql,,,,,,,,,@cErrorString )

IF !Empty(cErrorString)
  DCMSGBOX cErrorString
  RETURN .f.
ENDIF

USE balances VIA 'FOXCDX'

@ 0,0 DCBROWSE oBrowse ALIAS 'balances' SIZE 100,20 FIT ;
      FONT '10.Lucida Console'

DCBROWSECOL FIELD BALANCES->invoice HEADER 'Invoice' WIDTH 10 PARENT oBrowse
DCBROWSECOL FIELD BALANCES->balance HEADER 'Balance' WIDTH 10 PARENT oBrowse PICTURE '9999.99'
DCBROWSECOL FIELD BALANCES->customer HEADER 'Customer' WIDTH 30 PARENT oBrowse
DCBROWSECOL FIELD BALANCES->phone HEADER 'Phone' WIDTH 20 PARENT oBrowse

DCGETOPTIONS RESIZE RESIZEDEFAULT DCGUI_RESIZE_RESIZEONLY

DCREAD GUI FIT TITLE 'Browsing a database created by SQL' OPTIONS GetOptions

RETURN nil

* -----------

PROC appsys ; RETURN

