/*
 ķ
   Program..: _DCADS.PRG                                   
   Author...:  Roger J. Donnay                             
   Notice...: (c) DONNAY Software Designs 1987-2016        
   Date.....: Apr 12, 2016                                 
   Notes....: eXPress++ Advantage Server (ACE32.DLL)       
              Wrapper Functions and misc ADS function      
 Ľ

 A complete set of client functions for the Advantage Database
 server exists in ACE32.DLL.  This dynamic link library is
 included with the ADSDBE available from Alaska Software.  The
 below set of ADS*() DLLFUNCTION wrappers and AX_*() wrappers
 provide a much simpler interface to this robust database
 library.  The AX_*() wrappers are designed to be equivalent
 functions to those which exist in the Clipper 5.x client
 library.  To use this library in Xbase++ applications, include
 the DCLIPX.LIB file in your link script or project file and
 make sure that DCLIPX.DLL exists in your workstations search
 path.

 The complete set of AdsMg*() function wrappers is included
 with the ADSDBE product available from Alaska Software
 therefore they are not included here.  To use AdsMg*()
 functions in your application, include the ADSMG.LIB in
 your link script or project file and make sure that ADSMG.DLL
 exists in your workstation search path.

 The documentation for AX_() functions is included with the
 Clipper client kit available from Extended Systems.   The
 documentation for ADS*() functions is included with the
 ACE32 SDK also available from Extended Systems, therefore the
 functions are not documented here.  The ACE32 Client SDK is
 free.  Just visit http://www.advantagedatabase.com
*/


#INCLUDE "dll.ch"
#INCLUDE "common.ch"
#include 'dmlb.ch'
#include 'dbfdbe.ch'
#include 'dcdialog.ch'
#INCLUDE "dcads.CH"
#INCLUDE "appevent.CH"
#INCLUDE "dcprint.CH"
#INCLUDE "dcpick.CH"
#INCLUDE "dcmsg.CH"
#INCLUDE "dccargo.CH"
#INCLUDE "dctree.CH"
#INCLUDE "dcicon.CH"

#pragma library("ADAC20B.LIB")

EXTERNAL DC_AdsRunSQL

STATIC snHDll

* ---------------

#command  ACEFUNCTION <Func>([<x,...>]) ;
       => ;
FUNCTION <Func>([<x>]);;
STATIC scHCall := nil ;;
IF scHCall == nil ;;
  IF snHdll == nil ;;
    snHDll := DllLoad('ACE32.DLL') ;;
  ENDIF ;;
  scHCall := DllPrepareCall(snHDll,DLL_STDCALL,<(Func)>) ;;
ENDIF ;;
RETURN DllExecuteCall(scHCall,<x>)

* ----------------

#define KEYWORD_SELECT "SELECT"

* ------ ADS Driver Functions ------ *
/*
AdsApplicationExit
AdsBeginTransaction
AdsCacheOpenTables 
AdsCheckExistence
AdsClearDefault
AdsClearProgressCallback
AdsCommitTransaction
AdsConnect
AdsConnect26
AdsConnect60
AdsDisconnect
AdsFailedTransactionRecovery
AdsFindConnection
AdsFindConnection25
AdsGetAllTables
AdsGetCollationLang
AdsGetConnectionType
AdsGetDateFormat
AdsGetDecimals
AdsGetDefault
AdsGetDeleted
AdsGetEpoch
AdsGetErrorString
AdsGetExact
AdsGetExact22
AdsGetLastError
AdsGetNumOpenTables
AdsGetSearchPath
AdsGetServerName
AdsGetServerTime
AdsGetVersion
AdsInTransaction
AdsIsServerLoaded
AdsNullTerminateStrings
AdsRegisterProgressCallback
AdsRollbackTransaction
AdsSetCollationLang
AdsSetDateFormat
AdsSetDecimals
AdsSetDefault
AdsSetEpoch
AdsSetExact
AdsSetExact22
AdsSetSearchPath
AdsSetServerType
AdsShowDeleted
AdsShowError
AdsThreadExit
AdsWriteAllRecords
*/

ACEFUNCTION AdsApplicationExit()

ACEFUNCTION AdsBeginTransaction( nHandle )

ACEFUNCTION AdsCommitTransaction( nHandle )

ACEFUNCTION AdsCheckExistence( nHandle, cFileName, @lExist )

ACEFUNCTION AdsClearDefault()

ACEFUNCTION AdsClearProgressCallback()

ACEFUNCTION AdsConnect( cServerName, @nHandle )

ACEFUNCTION AdsConnect26( cServerName, nServerType, @nHandle )

ACEFUNCTION AdsConnect60( cServerName, nServerType, cUserName, cPassword, nOptions, @nHandle )

ACEFUNCTION AdsDisconnect( nHandle )

ACEFUNCTION AdsFailedTransactionRecovery( cServerPath )

ACEFUNCTION AdsFindConnection( cServerName, @nHandle )

ACEFUNCTION AdsFindConnection25( cFullPath, @nHandle )

ACEFUNCTION AdsFindClose( nDBConn, nFindHandle )

ACEFUNCTION AdsFindFirstTable( nDBConn, cMask, @cObjectName,@nObjectNameLen, @nFindHandle )

ACEFUNCTION AdsFindNextTable( nDBConn, nFindHandle, @cObjectName, @nObjectNameLen )

FUNCTION AdsGetAllTables( aTable, nLength )

   LOCAL xRet, i, cTable, nDll := DllLoad("ACE32.DLL")
   DEFAULT nLength TO 100, aTable TO {}
   cTable := Space( nLength * 4 )
   xRet := DllCall( nDll, 32, "AdsGetAllTables", @cTable, @nLength )
   DllUnLoad(nDll)
   ASize(aTable,nLength)
   FOR i := 1 TO nLength
     aTable[i] := Bin2L( SubStr(cTable,(i-1)*4+1,4))
   NEXT

RETURN xRet

ACEFUNCTION AdsGetConnectionType( nHandle, @nType )

ACEFUNCTION AdsGetDateFormat( @cDateFormat, @nBufferLength )

ACEFUNCTION AdsGetDecimals( @nDecimals )

ACEFUNCTION AdsGetDefault( @cDefaultPath, @nBufferLength )

ACEFUNCTION AdsGetDeleted( @lDeleted )

ACEFUNCTION AdsGetEpoch( @nEpoch )

ACEFUNCTION AdsGetErrorString( nError, @cErrorString, @nBufferLength ) //

ACEFUNCTION AdsGetExact( @lExact )

ACEFUNCTION AdsGetExact22( nHandle, @lExact )

ACEFUNCTION AdsGetLastError( @nError, @cErrorString, @nBufferLength )

ACEFUNCTION AdsGetNumOpenTables( @nTables )

ACEFUNCTION AdsGetSearchPath( @cSearchPath, @nBufferLength )

ACEFUNCTION AdsGetServerName( nHandle, @cServerName, @nBufferLength )

ACEFUNCTION AdsGetServerTime( nHandle, @cDate, @nDateBufferLength, @nTime, @cTime, @nTimeBufferLength )

ACEFUNCTION AdsGetVersion( @nMajor, @nMinor, @cVersion, @cDescription, @nDescBufferLength )

ACEFUNCTION AdsInTransaction( nHandle, @lInTrans )

ACEFUNCTION AdsIsServerLoaded( cServer, @nIsLoaded )

ACEFUNCTION AdsNullTerminateStrings( lNulTerm )

ACEFUNCTION AdsRegisterProgressCallback( bFunction, nPercent )

ACEFUNCTION AdsRollbackTransaction( nHandle )

ACEFUNCTION AdsSetDateFormat( cDateFormat )

ACEFUNCTION AdsSetDecimals( nDecimals )

ACEFUNCTION AdsSetDefault( cDefault )

ACEFUNCTION AdsSetEpoch( nEpoch )

ACEFUNCTION AdsSetExact( lExact )

ACEFUNCTION AdsSetExact22( nHandle, lExact )

ACEFUNCTION AdsSetSearchPath( cSearchPath )

ACEFUNCTION AdsSetServerType( nServerType )

ACEFUNCTION AdsShowDeleted( lShowDeleted )

ACEFUNCTION AdsShowError( cTitle )

ACEFUNCTION AdsWriteAllRecords()


* ------ ADS Table Functions ------ *

/*
AdsAddCustomKey
AdsAtBOF
AdsAtEOF
AdsCacheOpenTables
AdsCacheRecords
AdsCancelUpdate
AdsClearAllScopes
AdsClearAOF
AdsClearFilter
AdsClearRelation
AdsClearScope
AdsCloneTable
AdsCloseAllIndexes
AdsCloseAllTables
AdsCloseIndex
AdsCloseTable
AdsContinue
AdsConvertTable
AdsCopyTable
AdsCopyTableContents
AdsCopyTableStructure
AdsCreateIndex
AdsCreateIndex61
AdsCreateTable
AdsCustomizeAOF
AdsDecryptRecord
AdsDecryptTable
AdsDeleteCustomKey
AdsDeleteIndex
AdsDisableEncryption
AdsEnableEncryption
AdsEncryptRecord
AdsEncryptTable
AdsEvalAOF
AdsEvalLogicalExpr
AdsEvalNumericExpr
AdsEvalStringExpr
AdsEvalTestExpr
AdsExtractKey
AdsGetAllIndexes
AdsGetAllLocks
AdsGetAOF
AdsGetAOFOptLevel
AdsGetBookmark
AdsGetFieldDecimals
AdsGetFieldLength
AdsGetFieldName
AdsGetFieldNum
AdsGetFieldOffset
AdsGetFieldType
AdsGetFilter
AdsGetHandleLong
AdsGetHandleType
AdsGetIndexCondition
AdsGetIndexExpr
AdsGetIndexFilename
AdsGetIndexHandle
AdsGetIndexHandleByExpr
AdsGetIndexHandleByOrder
AdsGetIndexName
AdsGetIndexOrderByHandle
AdsGetKeyCount
AdsGetKeyLength
AdsGetKeyNum
AdsGetKeyType
AdsGetLastTableUpdate
AdsGetNumFields
AdsGetNumIndexes
AdsGetNumLocks
AdsGetRecordCount
AdsGetRecordLength
AdsGetRecordNum
AdsGetRelKeyPos
AdsGetScope
AdsGetTableAlias
AdsGetTableCharType
AdsGetTableConnection
AdsGetTableFilename
AdsGetTableHandle
AdsGetTableLockType
AdsGetTableOpenOptions
AdsGetTableRights
AdsGetTableType
AdsGotoBookmark
AdsGotoBottom
AdsGotoRecord
AdsGotoTop
AdsIsEncryptionEnabled
AdsIsExprValid
AdsIsFound
AdsIsIndexCompound
AdsIsIndexCustom
AdsIsIndexDescending
AdsIsIndexUnique
AdsIsRecordDeleted
AdsIsRecordEncrypted
AdsIsRecordInAOF
AdsIsRecordLocked
AdsIsRecordVisible
AdsIsTableEncrypted
AdsIsTableLocked
AdsLocate
AdsLockRecord
AdsLockTable
AdsLookupKey
AdsOpenIndex
AdsOpenTable
AdsPackTable
AdsRefreshAOF
AdsRefreshRecord
AdsReindex
AdsSeek
AdsSeekLast
AdsSetAOF
AdsSetFilter
AdsSetHandleLong
AdsSetRelation
AdsSetRelKeyPos
AdsSetScope
AdsSetScopedRelation
AdsSkip
AdsUnlockRecord
AdsUnlockTable
AdsVerifyPassword
AdsZapTable
*/

ACEFUNCTION AdsAddCustomKey( nIndex )

ACEFUNCTION AdsAtBOF( nTableHandle, @lStatus )

ACEFUNCTION AdsAtEOF( nTableHandle, @lStatus )

ACEFUNCTION AdsCacheOpenTables( nTables )

ACEFUNCTION AdsCacheRecords( nTableHandle, nRecords )

ACEFUNCTION AdsCancelUpdate( nTableHandle )

ACEFUNCTION AdsClearAllScopes( nTableHandle )

ACEFUNCTION AdsClearAOF( nTableHandle )

ACEFUNCTION AdsClearFilter( nTableHandle )

ACEFUNCTION AdsClearRelation( nParentHandle )

ACEFUNCTION AdsClearScope( nIndex, nScope )

ACEFUNCTION AdsCloneTable( nTableHandle, @nCloneHandle )

ACEFUNCTION AdsCloseAllIndexes( nTableHandle )

ACEFUNCTION AdsCloseAllTables()

ACEFUNCTION AdsCloseIndex( nIndex )

ACEFUNCTION AdsCloseTable( nTableHandle )

ACEFUNCTION AdsContinue( nTableHandle, @lStatus )

ACEFUNCTION AdsConvertTable( nTableHandle, nFilterOption, cFileName, nTableType )

ACEFUNCTION AdsCopyTable( nTableHandle, nFilterOption, cFileName )

ACEFUNCTION AdsCopyTableContents( nTableFrom, nTableTo, nFilterOption )

ACEFUNCTION AdsCopyTableStructure( nTableFrom, cFileName )

ACEFUNCTION AdsCreateIndex( nHandle, cFileName, cTagName, cKeyExpr, cCondition, cWhile, nOptions, @nIndex) ;

ACEFUNCTION AdsCreateIndex61( nHandle, cFileName, cTagName, cKeyExpr, cCondition, cWhile, nOptions, nPageSize, @nIndex) ;

ACEFUNCTION AdsCreateTable( nConnectHandle, cTableName, cAlias, nTableType, nCharType, nLockType, ;
                            nCheckRights, nMemoSize, cFields,  @nTableHandle) ;


ACEFUNCTION AdsCustomizeAOF( nTableHandle, nNumRecs, aRecords, nOption)

ACEFUNCTION AdsDecryptRecord( nTableHandle )

ACEFUNCTION AdsDecryptTable( nTableHandle )

ACEFUNCTION AdsDeleteCustomKey( nIndex )

ACEFUNCTION AdsDeleteIndex( nIndex )

ACEFUNCTION AdsDisableEncryption( nTableHandle )

ACEFUNCTION AdsEnableEncryption( nTableHandle, cPassWord )

ACEFUNCTION AdsEncryptRecord( nTableHandle )

ACEFUNCTION AdsEncryptTable( nTableHandle )

ACEFUNCTION AdsEvalAOF( nTableHandle, cFilter, nOptLevel )

ACEFUNCTION AdsExtractKey( nTableHandle, @cKey, @nBufferLen )

FUNCTION AdsGetAllIndexes( nTableHandle, aIndex, nLength )

LOCAL xRet, i, cIndex, nDll,nIndexes := 0
nLength := 100  // init pass-by-reference
aIndex  := {}   // "  " " "  " "
AdsGetNumIndexes(nTableHandle, @nIndexes)  // get number of indexes so we can correctly init call to AdsGetAllIndexes
nLength := nIndexes  // this is how many file handles we should get back
cIndex := SPACE( nLength * 4 )
nDll := DllLoad("ACE32.DLL")
xRet := DllCall( nDll, 32, "AdsGetAllIndexes", nTableHandle, @cIndex, @nLength )
DllUnLoad(nDll)
ASIZE(aIndex,nLength)
FOR i := 1 TO nLength
  aIndex[i] := Bin2L( SubStr(cIndex,(i-1)*4+1,4))
NEXT
RETURN xRet

FUNCTION AdsGetAllLocks( nTableHandle, aLocks, nLength )

   LOCAL xRet, i, cLocks, nDll := DllLoad("ACE32.DLL")
   DEFAULT nLength TO 100, aLocks TO {}
   cLocks := Space( nLength * 4 )
   xRet := DllCall( nDll, 32, "AdsGetAllLocks", nTableHandle, @cLocks, @nLength )
   DllUnLoad(nDll)
   ASize(aLocks,nLength)
   FOR i := 1 TO nLength
     aLocks[i] := Bin2L( SubStr(cLocks,(i-1)*4+1,4))
   NEXT

RETURN xRet

ACEFUNCTION AdsGetAOF( nTableHandle, @cFilter, @nBufferLen )

ACEFUNCTION AdsGetAOFOptLevel( nTableHandle, @nOptLevel, @cNonOpt, @nBufferLen )

ACEFUNCTION AdsGetBookMark( nTableHandle, @nRecord )

ACEFUNCTION AdsGetFieldDecimals( nTableHandle, cFieldName, @nDecimals ) //

ACEFUNCTION AdsGetFieldLength( nTableHandle, cFieldName, @nLength ) //

ACEFUNCTION AdsGetFieldName( nTableHandle, nFieldPos, @cFieldName, @nBufferLen ) //

ACEFUNCTION AdsGetFieldNum( nTableHandle, cFieldName, @nFieldPos ) //

ACEFUNCTION AdsGetFieldOffset( nTableHandle, cFieldName, @nOffset )

ACEFUNCTION AdsGetFieldType( nTableHandle, cFieldName, @nType ) //

ACEFUNCTION AdsGetFilter( nTableHandle, @cFilter, @nBufferLen )

ACEFUNCTION AdsGetHandleLong( nTableHandle, @nHandleLong )

ACEFUNCTION AdsGetHandleType( nTableHandle, @nHandleType )

ACEFUNCTION AdsGetIndexCondition( nIndex, @cCond, @nBufferLen )

ACEFUNCTION AdsGetIndexExpr( nIndex, @cExpr, @nBufferLen )

ACEFUNCTION AdsGetIndexFilename( nIndex, nOption, @cFileName, @nBufferLen )

ACEFUNCTION AdsGetIndexHandle( nTableHandle, cIndexName, @nHandle )

ACEFUNCTION AdsGetIndexHandleByExpr( nTableHandle, cExpr, nDescending, @nHandle )

ACEFUNCTION AdsGetIndexHandleByOrder( nTableHandle, nOrder, @nHandle )

ACEFUNCTION AdsGetIndexName( nIndex, @cIndexName, @nBufferLen )

ACEFUNCTION AdsGetIndexOrderByHandle( nIndex, @nOrder )

ACEFUNCTION AdsGetKeyCount( nIndex, nFilterOption, @nKeyCount )

ACEFUNCTION AdsGetKeyLength( nIndex, @nBytes )

ACEFUNCTION AdsGetKeyNum( nIndex, nFilterOption, @nKeyNo )

ACEFUNCTION AdsGetKeyType( nIndex, @nKeyType )

ACEFUNCTION AdsGetLastTableUpdate( nTableHandle, @cDate, @nBufferLen )

ACEFUNCTION AdsGetNumFields( nTableHandle, @nFieldCount )

ACEFUNCTION AdsGetNumIndexes( nTableHandle, @nIndexCount )

ACEFUNCTION AdsGetNumLocks( nTableHandle, @nLockCount )

ACEFUNCTION AdsGetRecordCount( nTableHandle, nFilterOption, @nRecCount )

ACEFUNCTION AdsGetRecordLength( nTableHandle, @nRecLength )

ACEFUNCTION AdsGetRecordNum( nTableHandle, nFilterOption, @nRecord )

ACEFUNCTION AdsGetRelKeyPos( nIndex, @nPosition )

ACEFUNCTION AdsGetScope( nIndex, nScopeOption, @cScope, @nBufferLen )

ACEFUNCTION AdsGetTableAlias( nTableHandle, @cAlias, @nBufferLen )

ACEFUNCTION AdsGetTableCharType( nTableHandle, @nCharType )

ACEFUNCTION AdsGetTableConnection( nTableHandle, @nConnection )

ACEFUNCTION AdsGetTableFilename( nTableHandle, nOption, @cFileName, @nBufferLen )

ACEFUNCTION AdsGetTableHandle( cAlias, @nTableHandle )

ACEFUNCTION AdsGetTableLockType( nTableHandle, @nLockType )

ACEFUNCTION AdsGetTableOpenOptions( nTableHandle, @nOptions )

ACEFUNCTION AdsGetTableRights( nTableHandle, @nRights )

ACEFUNCTION AdsGetTableType( nTableHandle, @nType )

ACEFUNCTION AdsGotoBookMark( nTableHandle, nBookMark )

ACEFUNCTION AdsGotoBottom( nTableHandle )

ACEFUNCTION AdsGotoRecord( nTableHandle, nRecord )

ACEFUNCTION AdsGotoTop( nTableHandle )

ACEFUNCTION AdsIsEncryptionEnabled( nTableHandle, @lStatus )

ACEFUNCTION AdsIsExprValid( nTableHandle, cExpression, @lStatus )

ACEFUNCTION AdsIsFound( nTableHandle, @lStatus )

ACEFUNCTION AdsIsIndexCompound( nIndex, @lStatus )

ACEFUNCTION AdsIsIndexCustom( nIndex, @lStatus )

ACEFUNCTION AdsIsIndexDescending( nIndex, @lStatus )

ACEFUNCTION AdsIsIndexUnique( nIndex, @lStatus )

ACEFUNCTION AdsIsRecordDeleted( nTableHandle, @lStatus )

ACEFUNCTION AdsIsRecordEncrypted( nTableHandle, @lStatus )

ACEFUNCTION AdsIsTableLocked( nTableHandle, @lStatus )

ACEFUNCTION AdsLocate( nTableHandle, cExpr, lForward, @lFound )

ACEFUNCTION AdsLockRecord( nTableHandle, nRecord )

ACEFUNCTION AdsLockTable( nTableHandle )

ACEFUNCTION AdsLookupKey( nIndex, cKey, nKeyLen, nDataType, @lFound )

ACEFUNCTION AdsOpenIndex( nTableHandle, cFileName, @aOrders, @nArrayLen )

ACEFUNCTION AdsOpenTable( nConnect, cName, cAlias, nTableType, nCharType, nLockType, nCheckRights, ;
                          nOptions, @nTableHandle )

ACEFUNCTION AdsPackTable( nTableHandle )

ACEFUNCTION AdsRefreshAOF( nTableHandle )

ACEFUNCTION AdsRefreshRecord( nTableHandle )

ACEFUNCTION AdsReindex( nTableHandle )

ACEFUNCTION AdsSeek( nIndex, @cKey, cLength, nDataType, nSeekType, @lFound )

ACEFUNCTION AdsSeekLast( nIndex, @cKey, cLength, nDataType, @lFound )

ACEFUNCTION AdsSetAOF ( nTableHandle, cFilter, nResolve )

ACEFUNCTION AdsSetFilter( nTableHandle, cFilter )

ACEFUNCTION AdsSetHandleLong( nTableHandle, nHandleLong )

ACEFUNCTION AdsSetRelation( nParentHandle, nChildIndex, cRelation )

ACEFUNCTION AdsSetRelKeyPos( nIndex, nRelKeyPos )

ACEFUNCTION AdsSetScope( nIndex,  nScopeOption, cScope, nScopeLen, nDataType )

ACEFUNCTION AdsSetScopedRelation( nParentHandle, nChildIndex, cScope )

ACEFUNCTION AdsSkip( nTableHandle, nRecords )

ACEFUNCTION AdsUnlockRecord( nTableHandle, nRecord )

ACEFUNCTION AdsUnlockTable( nTableHandle )

ACEFUNCTION AdsZapTable( nTableHandle )


* ------ ADS Data Manipulation Functions ------ *

/*
AdsAppendRecord
AdsBinaryToFile
AdsBuildRawKey
AdsDeleteRecord
AdsFileToBinary
AdsGetBinary
AdsGetBinaryLength
AdsGetDate
AdsGetDouble
AdsGetField
AdsGetJulian
AdsGetLogical
AdsGetLong
AdsGetMemoDataType
AdsGetMemoLength
AdsGetMilliseconds
AdsGetRecord
AdsGetShort
AdsGetString
AdsGetTime
AdsImageToClipboard
AdsInitRawKey
AdsIsEmpty
AdsRecallRecord
AdsSetBinary
AdsSetDate
AdsSetDouble
AdsSetEmpty
AdsSetField
AdsSetJulian
AdsSetLogical
AdsSetLong
AdsSetMilliseconds
AdsSetRecord
AdsSetShort
AdsSetString
AdsSetTime
AdsSetTimeStamp
AdsWriteRecord
*/

ACEFUNCTION AdsAppendRecord( nTableHandle )

ACEFUNCTION AdsBinaryToFile( nTableHandle, cFieldName, cFileName )

ACEFUNCTION AdsBuildRawKey( nIndex, @cKey, @nBufferLen )

ACEFUNCTION AdsDeleteRecord( nTableHandle )

ACEFUNCTION AdsFileToBinary( nTableHandle, cFieldName, nBinaryType, cFileName )

ACEFUNCTION AdsGetBinary( nTableHandle, cFieldName, nOffset, @cBuffer, @nBufferLen )

ACEFUNCTION AdsGetBinaryLength( nTableHandle, cFieldName, @nLength )

ACEFUNCTION AdsGetDate( nTableHandle, cFieldName, @cDate, @nBufferLen )

ACEFUNCTION AdsGetDouble( nTableHandle, cFieldName, @nValue )

ACEFUNCTION AdsGetField( nTableHandle, cFieldName, @cBuffer, @nBufferLen, nOption ) //

ACEFUNCTION AdsGetJulian( nTableHandle, cFieldName, @nJulian )

ACEFUNCTION AdsGetLogical( nTableHandle, cFieldName, @lValue )

ACEFUNCTION AdsGetLong( nTableHandle, cFieldName, @nValue )

ACEFUNCTION AdsGetMemoDataType( nTableHandle, cFieldName, @nMemoType )

ACEFUNCTION AdsGetMemoLength( nTableHandle, cFieldName, @nLength )

ACEFUNCTION AdsGetMilliseconds( nTableHandle, cFieldName, @nValue )

ACEFUNCTION AdsGetRecord( nTableHandle, @cBuffer, @nBufferLen )

ACEFUNCTION AdsGetShort( nTableHandle, cFieldName, @nValue )

ACEFUNCTION AdsGetString( nTableHandle, cFieldName, @cString, @nBufferLen, nOption )

ACEFUNCTION AdsGetTime( nTableHandle, cFieldName, @cTime, @nBufferLen )

ACEFUNCTION AdsImageToClipboard( nTableHandle, cFieldName )

ACEFUNCTION AdsInitRawKey( nIndex )

ACEFUNCTION AdsIsEmpty( nTableHandle, cFieldName, @lStatus )

ACEFUNCTION AdsRecallRecord( nTableHandle )

ACEFUNCTION AdsSetBinary( nTableHandle, cFieldName, nBinaryType, nTotalLength, nOffset, cBuffer, nBufferLen) ;


ACEFUNCTION AdsSetDate( nTableHandle, cFieldName, cDate, nBufferLen )

ACEFUNCTION AdsSetDouble( nTableHandle, cFieldName, nValue )

ACEFUNCTION AdsSetEmpty( nTableHandle, cFieldName )

ACEFUNCTION AdsSetField( nTableHandle, cFieldName, cData, nDataLen )

ACEFUNCTION AdsSetJulian( nTableHandle, cFieldName, nJulien )

ACEFUNCTION AdsSetLogical( nTableHandle, cFieldName, lValue )

ACEFUNCTION AdsSetLong( nTableHandle, cFieldName, nValue )

ACEFUNCTION AdsSetMilliseconds( nTableHandle, cFieldName, nValue )

ACEFUNCTION AdsSetRecord( nTableHandle, cBuffer, nRecLength )

ACEFUNCTION AdsSetShort( nTableHandle, cFieldName, nValue )

ACEFUNCTION AdsSetString( nTableHandle, cFieldName, cString, nStringLen )

ACEFUNCTION AdsSetTime( nTableHandle, cFieldName, cTime, nTimeLen )

ACEFUNCTION AdsSetTimeStamp( nTableHandle, cFieldName, cTime, nTimeLen )

ACEFUNCTION AdsWriteRecord( nTableHandle )


* ------ ADS SQL Functions ------ *

/*
AdsCacheOpenCursors
AdsClearSQLAbortFunc
AdsClearSQLParams
AdsCloseSQLStatement
AdsCreateSQLStatement
AdsExecuteSQL
AdsExecuteSQLDirect
AdsPrepareSQL
AdsRegisterSQLAbortFunc
AdsStmtClearTablePasswords
AdsStmtConstrainUpdates
AdsStmtDisableEncryption
AdsStmtEnableEncryption
AdsStmtSetTableCharType
AdsStmtSetTableLockTypea
AdsStmtSetTablePassword
AdsStmtSetTableReadOnly
AdsStmtSetTableRights
AdsStmtSetTableType
AdsCloseCachedTables
AdsGetSQLStatement
AdsGetSQLStatementHandle
*/

ACEFUNCTION AdsCacheOpenCursors( nCursors )

ACEFUNCTION AdsClearSQLAbortFunc()

ACEFUNCTION AdsClearSQLParams( nStatement )

ACEFUNCTION AdsCloseSQLStatement( nStatement )

ACEFUNCTION AdsCreateSQLStatement( nConnect, @nStatement )

ACEFUNCTION AdsExecuteSQL( nStatement, @nCursor )

ACEFUNCTION AdsExecuteSQLDirect( nStatement, cStatement, @nCursor )

ACEFUNCTION AdsPrepareSQL( nStatement, cStatement )

ACEFUNCTION AdsRegisterSQLAbortFunc( bFunction )

ACEFUNCTION AdsStmtClearTablePasswords( nStatement )

ACEFUNCTION AdsStmtConstrainUpdates( nStatement, nConstrain )

ACEFUNCTION AdsStmtDisableEncryption( nStatement )

ACEFUNCTION AdsStmtEnableEncryption( nStatement, cPassword )

ACEFUNCTION AdsStmtSetTableCharType( nStatement, nCharType )

ACEFUNCTION AdsStmtSetTableLockType( nStatement, nLockType )

ACEFUNCTION AdsStmtSetTablePassword( nStatement, cTableName, cPassword )

ACEFUNCTION AdsStmtSetTableReadOnly( nStatement, nReadOnly )

ACEFUNCTION AdsStmtSetTableRights( nStatement, nRights )

ACEFUNCTION AdsStmtSetTableType( nStatement, nRights )

ACEFUNCTION AdsVerifySQL( nStatement, cStatement )

ACEFUNCTION AdsCloseCachedTables( nHandle )

ACEFUNCTION AdsGetSQLStatement( nHandle, @cBuffer, @nLen )

ACEFUNCTION AdsGetSQLStatementHandle( nCursor, @nHandle )

* ------ ADS Management API Functions ------ *

/*
AdsMgConnect
AdsMgDisconnect
AdsMgGetActivityInfo
AdsMgGetCommStats
AdsMgGetConfigInfo
AdsMgGetInstallInfo
AdsMgGetLockOwner
AdsMgGetLocks
AdsMgGetOpenIndexes
AdsMgGetOpenTables
AdsMgGetServerType
AdsMgGetUserNames
AdsMgGetWorkerThreadActivity
AdsMgKillUser
AdsMgResetCommStats
*/

/*
DLLFUNCTION AdsMgConnect( cServerName, cUserName, cPassWord, @nConnectHandle ) USING STDCALL FROM ACE32.DLL

DLLFUNCTION AdsMgDisconnect( nConnectHandle ) USING STDCALL FROM ACE32.DLL

DLLFUNCTION AdsMgGetActivityInfo( nMgmtConnect, @aStructure, @nStructSize ) USING STDCALL FROM ACE32.DLL

DLLFUNCTION AdsMgGetCommStats( nMgmtConnect, @aStructure, @nStructSize ) USING STDCALL FROM ACE32.DLL

DLLFUNCTION AdsMgGetConfigInfo( nMgmtConnect, @aConfigValues, @nConfigValuesStructSize, @aConfigMemory, ;
                                @nConfigMemoryStructSize ) USING STDCALL FROM ACE32.DLL

DLLFUNCTION AdsMgGetInstallInfo( nMgmtConnect, @aInstallValues, @nInstallValuesStructSize ) ;
            USING STDCALL FROM ACE32.DLL

DLLFUNCTION AdsMgGetLockOwner( nMgmtConnect, cTableName, nRecordNumber, @aUserInfo, ;
                               @nStructSize, nLockType) USING STDCALL FROM ACE32.DLL

DLLFUNCTION AdsMgGetLocks( nMgmtConnect, cTableName, cUserName,  nConnNumber, ;
                           @aRecordInfo, @nArrayLen,  @nStructSize ) USING STDCALL FROM ACE32.DLL

DLLFUNCTION AdsMgGetOpenIndexes( nMgmtConnect, cTableName, cUserName, nConnNumber, ;
                                 @aOpenIndexInfo, @nArrayLen, @nStructSize ) USING STDCALL FROM ACE32.DLL

DLLFUNCTION AdsMgGetOpenTables( nMgmtConnect, cUserName, nConnNumber, @aOpenTableInfo, ;
                                @nArrayLen, @nStructSize ) USING STDCALL FROM ACE32.DLL

DLLFUNCTION AdsMgGetServerType( nMgmtConnect, @nServerType ) USING STDCALL FROM ACE32.DLL

DLLFUNCTION AdsMgGetUserNames( nMgmtConnect, cFileName, @aUserInfo, @nArrayLen, @nStructSize ) ;
            USING STDCALL FROM ACE32.DLL

DLLFUNCTION AdsMgGetWorkerThreadActivity( nMgmtConnect, @aWorkerThreadActivity, @nArrayLen, ;
                                          @nStructSize) USING STDCALL FROM ACE32.DLL

DLLFUNCTION AdsMgKillUser( nMgmtConnect, cUserName, nConnNumber ) USING STDCALL FROM ACE32.DLL

DLLFUNCTION AdsMgResetCommStats( nMgmtConnect ) USING STDCALL FROM ACE32.DLL
*/

* ------ ADS Data Dictionary Functions ------ *

/*
AdsDDAddIndexFile()
AdsDDAddProcedure()
AdsDDAddTable()
AdsDDAddUserToGroup()
AdsDDAddView()
AdsDDCreate()
AdsDDCreateLink()
AdsDDCreateRefIntegrity()
AdsDDCreateRefIntegrity62()
AdsDDCreateTrigger()
AdsDDCreateUser()
AdsDDCreateUserGroup()
AdsDDDeleteIndex()
AdsDDDeleteUser()
AdsDDDeleteUserGroup()
AdsDDDeployDatabase()
AdsDDDropLink()
AdsDDFindClose()
AdsDDFindFirstObject()
AdsDDFindNextObject()
AdsDDFreeTable()
AdsDDGetDatabaseProperty()
AdsDDGetFieldProperty()
AdsDDGetIndexFileProperty()
AdsDDGetIndexProperty()
AdsDDGetLinkProperty()
AdsDDGetPermissions()
AdsDDGetProcedureProperty()
AdsDDGetRefIntegrityProperty()
AdsDDGetTableProperty()
AdsDDGetTriggerProperty()
AdsDDGetUserGroupProperty()
AdsDDGetUserProperty()
AdsDDGetViewProperty()
AdsDDGrantPermission()
AdsDDModifyLink()
AdsDDRemoveIndexFile()
AdsDDRemoveProcedure()
AdsDDRemoveRefIntegrity()
AdsDDRemoveTable()
AdsDDRemoveTrigger()
AdsDDRemoveUserFromGroup()
AdsDDRemoveView()
AdsDDRevokePermission()
AdsDDSetDatabaseProperty()
AdsDDSetFieldProperty()
AdsDDSetProcedureProperty()
AdsDDSetTableProperty()
AdsDDSetUserGroupProperty()
AdsDDSetUserProperty()
AdsDDSetViewProperty()
*/

ACEFUNCTION AdsDDAddIndexFile( nAdminConn, cTableName, cIndexFilePath, cComment )
ACEFUNCTION AdsDDAddProcedure( nAdminConn, cName, cEAP, cProcName, nInvokeOption, cInParams, cOutParams, cComments )
ACEFUNCTION AdsDDAddTable( nAdminConn, cTableName, cTablePath, nTableType, nCharType, cIndexFiles, cComments )
ACEFUNCTION AdsDDAddUserToGroup( nAdminConn, cGroupName, cUserName )
ACEFUNCTION AdsDDAddView( nAdminConn, cName, cComments, cSQL )
ACEFUNCTION AdsDDCreate( cDictionaryPath, nEncrypt, cDescription, @nAdminConn )
ACEFUNCTION AdsDDCreateLink( nDBConn, cLinkAlias, cLinkedDDPath, cUserName, cPassword, nOptions )
ACEFUNCTION AdsDDCreateRefIntegrity( nAdminConn, cRIName, cFailTable, cParentTableName, pucParentTagName, ;
                                     cChildTableName, cChildTagName, nUpdateRule, nDeleteRule )
ACEFUNCTION AdsDDCreateRefIntegrity62( nAdminConn, cRIName, cFailTable, cParentTableName, pucParentTagName, ;
                                       cChildTableName, cChildTagName, nUpdateRule, nDeleteRule, ;
                                       cNoPrimaryError, cCascadeError )
ACEFUNCTION AdsDDCreateTrigger( nDictionary, cName, cTableName, nTriggerType, nEventTypes, ;
                                nContainerType, cContainer, cFunctionName, nPriority,  ;
                                cComments, nOptions )
ACEFUNCTION AdsDDCreateUser( nAdminConn, cGroupName, cUserName, cPassword, cDescription )
ACEFUNCTION AdsDDCreateUserGroup( nAdminConn, cGroupName, cDescription )
ACEFUNCTION AdsDDDeleteIndex( hAdminConn, cTableName, cIndexName )
ACEFUNCTION AdsDDDeleteUser( nAdminConn, cUserName )
ACEFUNCTION AdsDDDeleteUserGroup( nAdminConn, cGroupName )
ACEFUNCTION AdsDDDeployDatabase ( cDestination, cDestinationPassword, cSource, cSourcePassword, ;
                                  nServerTypes, nValidateOption, nBackupFiles, nOptions )
ACEFUNCTION AdsDDDropLink( nDBConn, cLinkedDD, lDropGlobal )
ACEFUNCTION AdsDDFindClose( nDBConn, nFindHandle )
ACEFUNCTION AdsDDFindFirstObject( nDBConn, nFindObjectType, cParentName, @cObjectName, ;
                                  @nObjectNameLen, @nFindHandle )
ACEFUNCTION AdsDDFindNextObject( nDBConn, nFindHandle, @cObjectName, @nObjectNameLen )
ACEFUNCTION AdsDDFreeTable( cTableName, cPassword )
ACEFUNCTION AdsDDGetDatabaseProperty( nDBConn, nPropertyID, @cProperty, @nPropertyLen )
ACEFUNCTION AdsDDGetFieldProperty( nDBConn, cTableName, cFieldName, nPropertyID, @nProperty, @nPropertyLen )
ACEFUNCTION AdsDDGetIndexFileProperty( nDBConn, cTableName, cIndexFileName, nPropertyID, @nProperty, @nPropertyLen )
ACEFUNCTION AdsDDGetIndexProperty( nDBConn, cTableName, cIndexName, nPropertyID, @nProperty, @nPropertyLen )
ACEFUNCTION AdsDDGetLinkProperty( nAdminConn, cLinkName, nPropertyID, @nProperty, @nPropertyLen )
ACEFUNCTION AdsDDGetPermissions( nAdminConn, cGrantee, nObjectType, cObjectName, cParentName, ;
                                 lGetInherited, @nPermissions )
ACEFUNCTION AdsDDGetProcedureProperty( nDBConn, cProcName, nPropertyID, @nProperty, @nPropertyLen )
ACEFUNCTION AdsDDGetRefIntegrityProperty( nDBConn, cRIName, nPropertyID, @cProperty, @nPropertyLen )
ACEFUNCTION AdsDDGetTableProperty( nDBConn, cTableName, nPropertyID, @nProperty, @nPropertyLen )
ACEFUNCTION AdsDDGetTriggerProperty( nObject, cTriggerName, nPropertyID, @nProperty, @nPropertyLen )
ACEFUNCTION AdsDDGetUserGroupProperty( nDBConn, cUserGroupName, nPropertyID, @nProperty, @nPropertyLen )
ACEFUNCTION AdsDDGetUserProperty( nDBConn, cUserName, nPropertyID, @nProperty, @nPropertyLen )
ACEFUNCTION AdsDDGetViewProperty( nDBConn, cViewName, nPropertyID, @nProperty, @nPropertyLen )
ACEFUNCTION AdsDDGrantPermission( nAdminConn, nObjectType, cObjectName, cParentName, cGrantee, nPermissions )
ACEFUNCTION AdsDDModifyLink( nDBConn, cLinkAlias, cLinkedDDPath, cUserName, cPassword, nOptions )
ACEFUNCTION AdsDDRemoveIndexFile( nAdminConn, cTableName, cIndexFileName, nDeleteFile )
ACEFUNCTION AdsDDRemoveProcedure( nAdminConn, cName )
ACEFUNCTION AdsDDRemoveRefIntegrity( nAdminConn, cRIName )
ACEFUNCTION AdsDDRemoveTable( nAdminConn, ucTableName, lDeleteFiles )
ACEFUNCTION AdsDDRemoveTrigger( nDictionary, cName )
ACEFUNCTION AdsDDRemoveUserFromGroup( nAdminConn, cGroupName, cUserName )
ACEFUNCTION AdsDDRemoveView( nAdminConn, cName )
ACEFUNCTION AdsDDRevokePermission( nAdminConn, nObjectType, cObjectName, cParentName, cGrantee, nPermissions )
ACEFUNCTION AdsDDSetDatabaseProperty( nAdminConn, nPropertyID, @nProperty, @nPropertyLen )
ACEFUNCTION AdsDDSetFieldProperty( nAdminConn, cTableName, cFieldName, nPropertyID, @nProperty, ;
                                   @nPropertyLen, nValidateOption, cFailTable )
ACEFUNCTION AdsDDSetProcedureProperty( nDBConn, cProcedureName, nPropertyID, @nProperty, @nPropertyLen )
ACEFUNCTION AdsDDSetTableProperty( nAdminConn, cTableName, nPropertyID, @nProperty, @nPropertyLen, ;
                                   nValidateOption, cFailTable )
ACEFUNCTION AdsDDSetUserGroupProperty( nAdminConn, cUserGroupName, nPropertyID, @nProperty, @nPropertyLen )
ACEFUNCTION AdsDDSetUserProperty( nDBConn, cUserName, nPropertyID, @nProperty, @nPropertyLen )
ACEFUNCTION AdsDDSetViewProperty( nDBConn, cViewName, nPropertyID, @nProperty, @nPropertyLen )


* ------ Clipper Compatability Functions ------ *

/*
AX_AXSLocking()    // included in ADSUTIL.DLL
AX_DbfDecrypt()    // included in ADSUTIL.DLL
AX_DbfEncrypt()    // included in ADSUTIL.DLL
AX_Decrypt()       // included in ADSUTIL.DLL
AX_Encrypt()       // included in ADSUTIL.DLL
AX_Error()         // included in ADSUTIL.DLL
AX_IDType()        // included in ADSUTIL.DLL
AX_RightsCheck()   // included in ADSUTIL.DLL
AX_SetPass()       // included in ADSUTIL.DLL
AX_TableType()     // included in ADSUTIL.DLL

AX_AutoOpen()         // not completed
AX_BLOB2File()
AX_CDXCheck()         // not completed
AX_ChooseOrgBagExt()
AX_ClearOrder()
AX_ClrScope()
AX_Driver()
AX_Error()
AX_ExprEngine()       // not supported in ACE32.DLL (always on)
AX_ExprError()        // not completed
AX_ExprValid()
AX_File2BLOB()
AX_FileOrder()        // not completed
AX_GetDrive()
AX_GetLocks()
AX_I_IndexName()      // not completed
AX_I_TagName()        // not completed
AX_IndexCount()
AX_IndexFilt()
AX_IndexName()
AX_IndexType()
AX_IsFlocked()
AX_IsLocked()
AX_IsReadOnly()
AX_IsReIndex()        // not completed
AX_IsShared()
AX_IsCustom()
AX_IsDescend()
AX_IsUnique()
AX_KeyAdd()
AX_KeyCount()
AX_KeyDrop()
AX_KeyNo()
AX_KeysIncluded()
AX_KeyVal()
AX_KillTag()
AX_Loaded()
AX_MemoArrayStyle     // not completed
AX_RddCount()
AX_RddInfo()
AX_Rlock()
AX_SeekLast()
AX_SetMemoBlock()
AX_SetRdd()
AX_SetScope()
AX_SetTag()
AX_SetTagNo()
AX_SetTagOrder()
AX_SkipUnique()
AX_TableName()
AX_TableType()
AX_TagInfo()
AX_TagName()
AX_TagNo()
AX_TagOrder()
AX_Tags()
AX_TPSCleanup()
AX_Transaction()
AX_Unlock()
AX_UserLockID()        // not completed
AX_Version()
AofFilterInfo()
*/


FUNCTION AX_AutoOpen()  // not completed
RETURN .t.

* ----------------

FUNCTION AX_BLOB2File( cFileName, cFieldName )

LOCAL nError, nHandle

nHandle := _GetTableHandle()
nError := AdsBinaryToFile( nHandle, cFieldName, cFileName )

RETURN nError == 0

* ----------------

FUNCTION AX_CDXCheck()  // not completed
RETURN .t.

* ----------------

FUNCTION AX_ChooseOrdBagExt( cExt )

RETURN DbeInfo( COMPONENT_ORDER, ADSDBE_INDEX_EXT, cExt )

* ----------------

FUNCTION AX_ClearOrder( nOrder )

LOCAL nHandle, nIndex, nError

nHandle := _GetTableHandle()
nIndex := 0
AdsGetIndexHandleByOrder( nHandle, nOrder, @nIndex )

nError := AdsCloseIndex( nIndex )

RETURN nError == 0

* ----------------

FUNCTION AX_ClrScope( nScope )

LOCAL nIndex, nHandle, nError
DEFAULT nScope TO 0
IF nScope = 0
  nScope := ADS_TOP
ELSEIF nScope = 1
  nScope := ADS_BOTTOM
ENDIF

nHandle := _GetTableHandle()
nIndex := 0
AdsGetIndexHandleByOrder( nHandle, OrdNumber(), @nIndex )

nError := AdsClearScope( nIndex, nScope )

RETURN nError == 0

* ----------------

FUNCTION AX_Driver()

LOCAL aList := DbeList()
RETURN  Ascan(aList,{|a|a[1]=='ADSDBE'}) > 0

* ----------------

FUNCTION AX_Error()

LOCAL nError := 0, cString, nLength

cString := Space(100)
nLength := 100
AdsGetLastError( @nError, @cString, @nLength )

RETURN nError

* ----------------

FUNCTION AX_ExprEngine( lOn ) // Not completed
RETURN .t.

* ----------------

FUNCTION AX_ExprError()  // Not completed
RETURN 0

* ----------------

FUNCTION AX_ExprValid( cExpression )

LOCAL nError, lStatus := .f., nHandle

nHandle := _GetTableHandle()
nError := AdsIsExprValid( nHandle, cExpression, @lStatus )

RETURN lStatus .AND. nError == 0

* ----------------

FUNCTION AX_File2BLOB( cFileName, cFieldName )

LOCAL nError, nHandle
nHandle := _GetTableHandle()
nError := AdsFileToBinary( nHandle, cFieldName, ADS_BINARY, cFileName )

RETURN nError == 0

* ----------------

FUNCTION AX_FileOrder() // Not completed

RETURN OrdNumber()

* ----------------

FUNCTION AX_GetDrive( cAlias )

LOCAL nError, nHandle, cFileName := Space(200)
nHandle := _GetTableHandle()
nError := AdsGetTableFilename( nHandle, ADS_FULLPATHNAME, @cFileName, 200 )

RETURN Trim(cFileName)

* ----------------

FUNCTION AX_GetLocks()

LOCAL nError, nHandle, aLocks

nHandle := _GetTableHandle()
nError := AdsGetAllLocks( nHandle, @aLocks, @nHandle )

RETURN aLocks

* ----------------

FUNCTION AX_I_IndexName() // Not completed
RETURN ''

* -----------------

FUNCTION AX_I_TagName() // Not completed
RETURN ''

* ----------------

FUNCTION AX_IndexCount()

LOCAL nHandle := 0, aIndex := {},  nLength := 0

nHandle := _GetTableHandle()
AdsGetAllIndexes( nHandle, @aIndex, @nLength )

RETURN LEN(aIndex)

* ----------------

FUNCTION AX_IndexFilt( nOrder )

LOCAL nHandle := 0, nLength := 1000, cFilter := SPACE(nLength), nIndex := 0
IF Empty(Alias())
   RETURN ''
ENDIF
nHandle := _GetTableHandle()
DEFAULT nOrder TO OrdNumber()
AdsGetIndexHandleByOrder( nHandle, nOrder, @nIndex )
AdsGetIndexCondition( nIndex, @cFilter, @nLength )

RETURN SUBSTR(cFilter,1,nLength)

* ----------------

FUNCTION AX_IndexName( nOrder )

LOCAL nHandle := 0, nLength := 1000, cName := SPACE(nLength), nIndex := 0

IF Empty(Alias())
   RETURN ''
ENDIF
nHandle := _GetTableHandle()
DEFAULT nOrder TO OrdNumber()
AdsGetIndexHandleByOrder( nHandle, nOrder, @nIndex )
AdsGetIndexFileName( nIndex, ADS_FULLPATHNAME, @cName, @nLength )

RETURN SUBSTR(cName,1,nLength)

* ----------------

FUNCTION AX_IndexType( cnOrder )  // contributed by Mark Butler

LOCAL nHandle := 0, nIndex := 0,nIsCompound := 0,nLength := 1000,;
      cIndexName := SPACE(nLength),nError := 0
/* From the Advantage Norton Guide:
Returns   0 = No index found
          1 = Non-compact IDX  (unsupported, can't identify this type)
          2 = Compact IDX
          3 = CDX
          4 = NTX
*/
IF Empty(Alias()) .OR. OrdNumber() = 0
   RETURN 0 // no index found
ENDIF
nHandle := _GetTableHandle()
IF Valtype(cnOrder) = 'N'
   nError := AdsGetIndexHandleByOrder( nHandle, cnOrder, @nIndex )
ELSEIF Valtype(cnOrder) = 'C'
   nError := AdsGetIndexHandle( nHandle, cnOrder, @nIndex )
ELSE
   nError := AdsGetIndexHandleByOrder( nHandle, OrdNumber(), @nIndex )
ENDIF
IF nError != 0
   RETURN 0  // bad order name/number specified or other error
ENDIF
AdsIsIndexCompound( nIndex, @nIsCompound )
IF nIsCompound != 0
   RETURN 3  // compound indexes are CDX type
ENDIF
// non-compound index, use file extension to determine return value
AdsGetIndexFileName( nIndex, ADS_FULLPATHNAME, @cIndexName, @nLength )
cIndexName := SUBSTR(cIndexName,1,nLength)
IF SUBSTR(cIndexName,RAT('.',cIndexName) + 1) == 'NTX'
   RETURN 4  // NTX type (this only works if user is using standard file extensions)
ENDIF

RETURN 2 // assume Compact IDX

* ----------------

FUNCTION AX_IsFlocked()

LOCAL lIsLocked := .f., nHandle

IF Empty(Alias())
  RETURN .f.
ENDIF
nHandle := _GetTableHandle()
AdsIsTableLocked( nHandle, @lIsLocked )

RETURN lIsLocked

* ----------------

FUNCTION AX_IsLocked( nRecNo )

LOCAL aLocks
IF Empty(Alias())
  RETURN .f.
ENDIF
aLocks := AX_GetLocks()
DEFAULT nRecNo TO RecNo()

RETURN aScan( aLocks, nRecNo ) > 0

* ----------------

FUNCTION AX_IsReadOnly()

LOCAL nHandle, nOptions
IF Empty(Alias())
  RETURN .f.
ENDIF
nHandle := _GetTableHandle()
nOptions := 0
AdsGetTableOpenOptions( nHandle, @nOptions )

RETURN DC_BitTest( nOptions, ADS_READONLY )

* ----------------

FUNCTION AX_IsReindex() // Not Completed
RETURN .f.

* ----------------

FUNCTION AX_IsShared()

LOCAL lIsShared
IF !EMPTY(Alias())
  lIsShared := dbInfo( DBO_SHARED )
ELSE
  lIsShared := !SET(_SET_EXCLUSIVE)
ENDIF
RETURN lIsShared

* ----------------

FUNCTION AX_IsCustom( cnOrder, cCDXName )

LOCAL lCustom := .f., nHandle, nIndex
IF Empty(Alias())
  RETURN .f.
ENDIF
nHandle := _GetTableHandle()
nIndex := 0
IF Valtype(cnOrder) = 'N'
  AdsGetIndexHandleByOrder( nHandle, cnOrder, @nIndex )
ELSEIF Valtype(cnOrder) = 'C'
  AdsGetIndexHandle( nHandle, cnOrder, @nIndex )
ELSE
  AdsGetIndexHandleByOrder( nHandle, OrdNumber(), @nIndex )
ENDIF
AdsIsIndexCustom( nIndex, @lCustom )

RETURN lCustom

* ----------------

FUNCTION AX_IsDescend( cnOrder, cCDXName )

LOCAL lDescend := .f., nHandle, nIndex
IF Empty(Alias())
  RETURN .f.
ENDIF
nHandle := _GetTableHandle()
nIndex := 0
IF Valtype(cnOrder) = 'N'
  AdsGetIndexHandleByOrder( nHandle, cnOrder, @nIndex )
ELSEIF Valtype(cnOrder) = 'C'
  AdsGetIndexHandle( nHandle, cnOrder, @nIndex )
ELSE
  AdsGetIndexHandleByOrder( nHandle, OrdNumber(), @nIndex )
ENDIF
AdsIsIndexDescending( nIndex, @lDescend )

RETURN lDescend

* ----------------

FUNCTION AX_IsUnique( cnOrder, cCDXName )

LOCAL lUnique := .f., nHandle, nIndex, cFileName
IF Empty(Alias())
  RETURN .f.
ENDIF
nHandle := _GetTableHandle()
nIndex := 0
IF Valtype(cnOrder) = 'N'
  AdsGetIndexHandleByOrder( nHandle, cnOrder, @nIndex )
ELSEIF Valtype(cnOrder) = 'C'
  AdsGetIndexHandle( nHandle, cnOrder, @nIndex )
ELSE
  AdsGetIndexHandleByOrder( nHandle, OrdNumber(), @nIndex )
ENDIF
AdsIsIndexUnique( nIndex, @lUnique )

RETURN lUnique

* ----------------

FUNCTION AX_KeyAdd( cnOrder, cCDXName )

LOCAL nHandle, nIndex
IF Empty(Alias())
  RETURN .f.
ENDIF
nHandle := _GetTableHandle()
nIndex := 0
IF Valtype(cnOrder) = 'N'
  AdsGetIndexHandleByOrder( nHandle, cnOrder, @nIndex )
ELSEIF Valtype(cnOrder) = 'C'
  AdsGetIndexHandle( nHandle, cnOrder, @nIndex )
ELSE
  AdsGetIndexHandleByOrder( nHandle, OrdNumber(), @nIndex )
ENDIF

RETURN AdsAddCustomKey( nIndex ) == 0

* ----------------

FUNCTION AX_KeyCount( cnOrder, cCDXName )

LOCAL nHandle, nIndex, nKeys := 0, cFileName

IF Empty(Alias())
  RETURN nKeys
ENDIF
nHandle := _GetTableHandle()
nIndex := 0

IF Valtype(cnOrder) = 'N'
  AdsGetIndexHandleByOrder( nHandle, cnOrder, @nIndex )
ELSEIF Valtype(cnOrder) = 'C'
  AdsGetIndexHandle( nHandle, cnOrder, @nIndex )
ELSE
  AdsGetIndexHandleByOrder( nHandle, OrdNumber(), @nIndex )
ENDIF

AdsGetKeyCount( nIndex, ADS_RESPECTSCOPES, @nKeys )

RETURN nKeys

* ----------------

FUNCTION AX_KeyDrop( cnOrder, cCDXName )

LOCAL nHandle, nIndex
IF Empty(Alias())
  RETURN .f.
ENDIF
nHandle := _GetTableHandle()
nIndex := 0
IF Valtype(cnOrder) = 'N'
  AdsGetIndexHandleByOrder( nHandle, cnOrder, @nIndex )
ELSEIF Valtype(cnOrder) = 'C'
  AdsGetIndexHandle( nHandle, cnOrder, @nIndex )
ELSE
  AdsGetIndexHandle( nHandle, OrdNumber(), @nIndex )
ENDIF

RETURN AdsDeleteCustomKey( nIndex ) == 0

* ----------------

FUNCTION AX_KeyNo( cnOrder, cCDXName )

LOCAL nHandle, nIndex, nKey := 0, cFileName
IF Empty(Alias())
  RETURN nKey
ENDIF
nHandle := _GetTableHandle()
nIndex := 0
IF Valtype(cnOrder) = 'N'
  AdsGetIndexHandleByOrder( nHandle, cnOrder, @nIndex )
ELSEIF Valtype(cnOrder) = 'C'
  AdsGetIndexHandle( nHandle, cnOrder, @nIndex )
ELSE
  AdsGetIndexHandleByOrder( nHandle, OrdNumber(), @nIndex )
ENDIF
AdsGetKeyNum( nIndex, ADS_RESPECTSCOPES, @nKey )

RETURN nKey

* ----------------

FUNCTION AX_KeysIncluded()

LOCAL nHandle, nIndex, nKeys := 0
IF Empty(Alias())
  RETURN nKeys
ENDIF
nHandle := _GetTableHandle()
nIndex := 0
AdsGetIndexHandle( nHandle, OrdNumber(), @nIndex )
AdsGetKeyCount( nIndex, ADS_IGNOREFILTERS, @nKeys )

RETURN nKeys

* ----------------

FUNCTION AX_KeyVal( cnOrder, cCDXName )

LOCAL nHandle, cExpr, nLength, nIndex
IF Empty(Alias())
  RETURN nil
ENDIF
nHandle := _GetTableHandle()
nIndex := 0
IF Valtype(cnOrder) = 'N'
  AdsGetIndexHandleByOrder( nHandle, cnOrder, @nIndex )
ELSEIF Valtype(cnOrder) = 'C'
  AdsGetIndexHandle( nHandle, cnOrder, @nIndex )
ELSE
  AdsGetIndexHandle( nHandle, OrdNumber(), @nIndex )
ENDIF
cExpr := Space(500)
nLength := 500
AdsGetIndexExpr( nIndex, @cExpr, @nLength )
cExpr := Alltrim(cExpr)

RETURN IIF( !Empty(cExpr),&(cExpr),nil )

* ----------------

FUNCTION AX_KillTag( lcTagName, cCDXName )

LOCAL nHandle, cExpr, nLength, nIndex, nError, nOrder
IF Empty(Alias())
  RETURN nil
ENDIF
nHandle := _GetTableHandle()
nIndex := 0
nError := 0
IF Valtype(lcTagName) = 'C'
  AdsGetIndexHandle( nHandle, lcTagName, @nIndex )
  nError := AdsDeleteIndex(nIndex)
ELSEIF Valtype(lcTagName) = 'L' .AND. lcTagName
  FOR nOrder := 1 TO 100
    nIndex := 0
    AdsGetIndexHandleByOrder( nHandle, nOrder, @nIndex )
    IF nIndex # 0
      AdsDeleteIndex(nIndex)
    ELSE
      EXIT
    ENDIF
  NEXT
ENDIF

RETURN nError == 0

* ----------------

STATIC FUNCTION _GetTableHandle()

LOCAL nHandle := 0, cFileName

cFileName := DbInfo(DBO_FILENAME)
AdsGetTableHandle( cFileName, @nHandle )
IF nHandle == 0
  cFileName := DC_DbCargo()[DCCARGO_DBF_NAME]
  AdsGetTableHandle( cFileName, @nHandle )
ENDIF

RETURN nHandle

* ----------------

FUNCTION AX_Loaded( cServer, nLoaded )

LOCAL nError

/*

Updated my Mark Butler.  Here are his notes (Thanks Mark) :

nLoaded will be set to the server type if Advantage is
loaded/started on the specified server and if no server is available.
The server types are ADS_AIS_SERVER, ADS_REMOTE_SERVER, and ADS_LOCAL_SERVER.
NOTE: I extended the functionality of AX_Loaded() by including the
nLoaded parm which according to the ACE SDK docs will return the
type of ADS server you're connected to.

*/

nLoaded := 0 // init pass-by-reference prior to DLLCall

nError := AdsIsServerLoaded( cServer, @nLoaded )

RETURN nError == 0

* ----------------

FUNCTION AX_MemoArrayStyle( cMemoStyle ) // Not supported
RETURN ''

* ----------------

FUNCTION AX_RddCount()

RETURN Len(DbeList())

* ----------------

FUNCTION AX_RddInfo( nArea )

LOCAL nSaveArea := nArea, cRddName, cOldDbe := dbeSetDefault(), aRddInfo

IF Valtype(nArea) = 'N'
  cRddName := DbInfo( DBO_DBENAME )
ELSEIF Valtype(nArea) = 'C'
  cRddName := nArea
ENDIF
aRddInfo := { ;
         cRddName, ;
         .t., ;
         DbeInfo( COMPONENT_DATA, DBE_EXTENSION ), ;
         DbeInfo( COMPONENT_ORDER, DBE_EXTENSION ), ;
         '', ;
         DbeInfo( COMPONENT_DATA, ADSDBE_MEMOFILE_EXT ) }

dbeSetDefault(cRddName)
SELE (nSaveArea)

RETURN aRddInfo

* ----------------

FUNCTION AX_RLock( naRecord )

LOCAL nHandle, aRecords, aStatus, i, nStatus

IF Empty(Alias())
  RETURN .f.
ENDIF
nHandle := _GetTableHandle()
IF Empty( naRecord )
  naRecord := RecNo()
ENDIF
IF Valtype( naRecord ) = 'N'
  aRecords := { naRecord }
ENDIF
aStatus := Array(Len(aRecords))
FOR i := 1 TO Len(aRecords)
   nStatus := AdsLockRecord( nHandle, aRecords[i] )
   aStatus[i] := IIF( nStatus==AE_LOCK_FAILED,.f.,.t. )
NEXT
IF Valtype(naRecord) = 'N'
   RETURN aStatus[1]
ENDIF
RETURN aStatus

* ----------------

FUNCTION AX_SeekLast( xKey, lSoftSeek )

LOCAL nIndex := 0, nKeyLen, lFound := .f., nHandle, nError

IF Empty(Alias())
  RETURN .f.
ENDIF
nHandle := _GetTableHandle()
AdsGetIndexHandleByOrder( nHandle, OrdNumber(), @nIndex )
IF Valtype(xKey) = 'C'
  nKeyLen := Len(xKey)
  nError := AdsSeekLast( nIndex, xKey, nKeyLen, ADS_STRINGKEY, @lFound )
ELSEIF Valtype(xKey) = 'N'
  nError := AdsSeekLast( nIndex, xKey, 8, ADS_DOUBLEKEY, @lFound )
ENDIF

RETURN lFound

* ----------------

FUNCTION AX_SetMemoBlock( nBlockSize )

RETURN dbeInfo( COMPONENT_DATA, ADSDBE_MEMOBLOCKSIZE, nBlockSize )

* ----------------

FUNCTION AX_SetFileOrd( nFileOrd )
RETURN .f.

* ----------------

FUNCTION AX_SetRdd( cRdd )

RETURN dbeSetDefault( cRdd )

* ----------------

/*
FUNCTION AX_SetScope( nScope, xKey )

LOCAL nIndex, nHandle, nError, nKeyLen, xOldScope
DEFAULT nScope TO 0
IF nScope = 0
  nScope := ADS_TOP
ELSEIF nScope = 1
  nScope := ADS_BOTTOM
ENDIF

nHandle := _GetTableHandle()

nIndex := 0
AdsGetIndexHandleByOrder( nHandle, OrdNumber(), @nIndex )

xOldScope := Space(100)
nKeyLen := 100
nError := AdsGetScope( nIndex, nScope, @xOldScope, @nKeyLen )
IF Valtype(xOldScope) = 'C'
   xOldScope := Pad(xOldScope,nKeyLen)
ENDIF

IF Valtype(xKey) = 'C'
  nKeyLen := Len(xKey)
  nError := AdsSetScope( nIndex, nScope, xKey, @nKeyLen, ADS_STRINGKEY )
ELSEIF Valtype(xKey) = 'N'
  nError := AdsSetScope( nIndex, nScope, xKey, 8, ADS_DOUBLEKEY )
ENDIF

RETURN xOldScope
*/

FUNCTION AX_SetScope( nScopeType, xScope )

LOCAL rc, hIndex, nHandle, nKeys
LOCAL cLen, nLen, nType, cType
LOCAL cBuffer // decouple passed value (ANSI/OEM conv!)

DEFAULT nScopeType TO 0
IF nScopeType = 0
  nScopeType := ADS_TOP
ELSEIF nScopeType = 1
  nScopeType := ADS_BOTTOM
ENDIF

nHandle := _GetTableHandle()

hIndex := 0
AdsGetIndexHandleByOrder( nHandle, OrdNumber(), @hIndex )

// no scope value: query current scope value

IF PCount() == 1
   cBuffer := space(128)
   cLen := W2Bin(len(cBuffer))
   rc := AdsGetScope( hIndex, nScopeType, @cBuffer, @cLen )
   // AdsExtErrorCheck( rc, AE_NO_SCOPE )
   cBuffer := SubStr( cBuffer, 1, Bin2W(cLen))
   RETURN cBuffer
ENDIF

cType := Valtype( xScope )

// check type of scope value and convert to character

DO CASE
CASE cType == "C"
   nLen   := Len( xScope )
   nType  := ADS_STRINGKEY

   // convert to ANSI if we are running OEM
   IF Set( _SET_CHARSET ) == CHARSET_OEM
      cBuffer := ConvToAnsiCp( xScope )
   ELSE
      cBuffer := xScope
   ENDIF

CASE cType == "D"
   nLen    := 8
   nType   := ADS_STRINGKEY
   cBuffer := DTOS( xScope )

CASE cType == "L"
   nLen    := 1
   nType   := ADS_STRINGKEY
   cBuffer := IIF( xScope, "T", "F" )

CASE cType == "N"
   cBuffer    := f2bin( xScope )
   nLen       := LEN( cBuffer )
   nType      := ADS_DOUBLEKEY

OTHERWISE
    RETURN NIL
ENDCASE

rc := AdsSetScope( hIndex, nScopeType, @cBuffer, nLen, nType )

// AdsExtErrorCheck( rc )

RETURN xScope

* ----------------

FUNCTION AX_SetTag( ncTagName, cCDXName )

IF Empty(Alias())
  RETURN .f.
ENDIF

RETURN OrdSetFocus( ncTagName )

* ----------------

FUNCTION AX_SetTagNo( ncTagName, cCDXName )

IF Empty(Alias())
  RETURN .f.
ENDIF

RETURN OrdSetFocus( ncTagName )

* ----------------

FUNCTION AX_SetTagOrder( nPosition )

RETURN dbSetOrder( nPosition )

* ----------------

FUNCTION AX_SkipUnique( nDirection )

LOCAL xValue, xNewValue, nRecNo := RecNo(), cIndexKey

cIndexKey := IndexKey(0)
IF Empty(cIndexKey)
  RETURN .f.
ENDIF

xValue := &(cIndexKey)

DEFAULT nDirection TO 1
IF nDirection == 1
  SKIP
  xNewValue := &(IndexKey(0))
  IF xNewValue == xValue
    AX_SeekLast(xNewValue)
    SKIP
  ENDIF
ELSE
  SKIP -1
  xNewValue := &(IndexKey(0))
  IF xNewValue == xValue .AND. !Bof()
    SEEK xNewValue
    SKIP -1
  ENDIF
ENDIF

RETURN ( nRecNo # RecNo() )

* -----------------

FUNCTION AX_TableName()

LOCAL nHandle := 0, nLength := 1000, cFileName := Space(nLength)

IF Empty(Alias())
   RETURN ''
ENDIF
nHandle := _GetTableHandle()
AdsGetTableFilename( nHandle, ADS_FULLPATHNAME, @cFileName, @nLength )

RETURN SUBSTR(cFileName,1,nLength)

* -----------------

/*
FUNCTION AX_TableType()
LOCAL nHandle, lIsEncrypted := .f.

IF Empty(Alias())
  RETURN 0
ENDIF
nHandle := 0
AdsGetTableHandle( DBInfo(DBO_FILENAME), @nHandle )

AdsIsEncryptionEnabled( nHandle, @lIsEncrypted )

RETURN IIF( lIsEncrypted, 2, 1 )
*/

* -----------------

FUNCTION AX_TagCount( nFileOrder, lIsCompound )

LOCAL nHandle := 0, nIndex := 0, nLength := 0, aIndex := {}
lIsCompound := FALSE // init pass-by-reference (NOTE: This is extended functionality, we need it for AX_TagInfo() & AX_Tags())
IF Empty(Alias()) .OR. OrdNumber() = 0
   RETURN 0
ENDIF
IF VALTYPE(nFileOrder) != 'N'
   nFileOrder := OrdNumber()
ENDIF
nHandle := _GetTableHandle()
AdsGetAllIndexes( nHandle, @aIndex, @nLength )
nIndex := aIndex[nFileOrder]  // got index handle of index specified by <nFileOrder>
// return now depends on type of index specified by <nFileOrder>
lIsCompound := 0
AdsIsIndexCompound( nIndex, @lIsCompound )
lIsCompound := lIsCompound != 0  // fixup return of pass-by-reference
IF lIsCompound
   RETURN LEN(aIndex)
ENDIF
RETURN 1  // non-compound indexes only have 1 order "tag"

* -----------------

FUNCTION AX_TagInfo( nFileOrder )

/* From the Advantage Norton Guide:
   Returns a multi-dimensional array containing information about each
  tag in the .cdx file.  If the specified order is invalid or no index
  is open, it returns an empty array.

  This function returns an array of six element arrays, each containing
  information about a tag within the current or specified .cdx file.
  If <nFileOrder> is not specified, the current index is used.

  The following information is returned for each tag:
       [1] = Tag name
       [2] = Index key expression
       [3] = FOR clause expression (or "" if no FOR clause)
       [4] = Logical value - .T. if index is UNIQUE
       [5] = Logical value - .T. if index is DESCENDING order
       [6] = Logical value - .T. if index is CUSTOM order

  This function can also be used with .idx and .ntx files.  It returns a
  single element array containing an array with the above information.
  The index name is given in place of the tag name.
*/

LOCAL nTags, aTagInfo := {}, i,lIsCompound
IF Empty(Alias()) .OR. OrdNumber() = 0
   RETURN {}
ENDIF
IF VALTYPE(nFileOrder) != 'N'
   nFileOrder := OrdNumber()
ENDIF
// Get number of tags for current CDX or NTX or IDX
nTags := AX_TagCount(nFileOrder,@lIsCompound )
IF lIsCompound
   // compound index CDX
   FOR i := 1 TO nTags
      // Store tag info for all tags in .CDX
      AADD(aTagInfo,{ AX_TagName(i), ;
                      IndexKey(i), ;
                      AX_IndexFilt(i), ;
                      AX_IsUnique(i), ;
                      AX_IsDescend(i), ;
                      AX_IsCustom(i) })
   NEXT
ELSE
   // non-compound index NTX or IDX
   FOR i := 1 TO nTags
      // Store tag info for NTX or IDX - single order
      AADD(aTagInfo,{ AX_TagName(nFileOrder), ;
                      IndexKey(nFileOrder), ;
                      AX_IndexFilt(nFileOrder), ;
                      AX_IsUnique(nFileOrder), ;
                      AX_IsDescend(nFileOrder), ;
                      AX_IsCustom(nFileOrder) })
   NEXT
ENDIF
RETURN aTagInfo

* -----------------

FUNCTION AX_TagName( nFileOrder )

LOCAL nHandle := 0, nIndex := 0, nLength := 128, cTagName := SPACE(nLength)

IF Empty(Alias()) .OR. OrdNumber() = 0
   RETURN ''
ENDIF
IF VALTYPE(nFileOrder) != 'N'
   nFileOrder := OrdNumber()
ENDIF
nHandle := _GetTableHandle()
AdsGetIndexHandleByOrder( nHandle, nFileOrder, @nIndex )
AdsGetIndexName( nIndex, @cTagName, @nLength )

RETURN SUBSTR(cTagName,1,nLength)

* -----------------

FUNCTION AX_TagNo( nFileOrder ) // Not completed

RETURN OrdNumber()

* -----------------

FUNCTION AX_TagOrder()

RETURN OrdNumber()

* -----------------

FUNCTION AX_Tags( nFileOrder )
LOCAL lIsCompound, nTags, aTags := {},i
// Get number of tags for current CDX or NTX or IDX
IF (nTags := AX_TagCount(nFileOrder,@lIsCompound )) = 0
   RETURN {}
ENDIF
IF lIsCompound
   // Store tag name for all tags in .CDX
   FOR i := 1 TO nTags
      AADD(aTags,AX_TagName(i))
   NEXT
ELSE
   // Store tag name for NTX or IDX - single order
   AADD(aTags,AX_TagName(nFileOrder))
ENDIF
RETURN aTags

* -----------------

FUNCTION AX_TPSCleanUp( cServerName )

LOCAL nError
nError := AdsFailedTransactionRecovery( cServerName )
RETURN nError == 0

* -----------------

FUNCTION AX_Transaction( nMode )

LOCAL nError, nHandle

DEFAULT nMode TO 0
nHandle := _GetTableHandle()

IF nMode = 1
  nError := AdsBeginTransaction( nHandle )
ELSEIF nMode = 2
  nError := AdsCommitTransaction( nHandle )
ELSEIF nMode = 3
  nError := AdsRollbackTransaction( nHandle )
ENDIF

RETURN nError == 0

* -----------------

FUNCTION AX_UnLock( naRecord )

LOCAL nHandle, aRecords, i

IF Empty(Alias())
  RETURN nil
ENDIF
nHandle := _GetTableHandle()
IF Empty(naRecord)
   AdsUnlockTable( nHandle )
ELSE
  IF Empty( naRecord )
    naRecord := RecNo()
  ENDIF
  IF Valtype( naRecord ) = 'N'
    aRecords := { naRecord }
  ENDIF
  FOR i := 1 TO Len(aRecords)
     AdsUnlockRecord( nHandle, aRecords[i] )
  NEXT

ENDIF
RETURN nil

* -----------------

FUNCTION AX_UserLockID( nRecNo ) // Not completed
RETURN ''


* ------------------

FUNCTION AX_Version ( nType ) // Contributed by Mark Butler

LOCAL xReturn := '',nMajor := 0, nMinor := 0, nLength := 500, ;
      cVersion := SPACE(1),cDescription := SPACE(nLength),;
      aFile,cDLL := 'ACE32.DLL',dDate := CTOD(''),cTime := ''

IF VALTYPE(nType) != 'N'
   nType := 0
ENDIF
AdsGetVersion( @nMajor, @nMinor, @cVersion, @cDescription, @nLength )
cDescription := SUBSTR(cDescription,1,nLength)
// get date/time of ACE32.DLL
IF EMPTY(aFile := DIRECTORY(cDLL))
   // didn't find it in the current dir, check EXE dir
   aFile := DIRECTORY(LEFT(AppName(.T.),RAT('\',AppName(.T.))) + cDLL)
ENDIF
IF LEN(aFile) > 0
   dDate := aFile[1,3]
   cTime := aFile[1,4]
ENDIF
// From the Advantage Norton Guide:
// Returns one of four values, depending on the value of nType:
DO CASE
CASE nType == 0
   // 0 = Primary version number as a string ( "5.0" )
   xReturn := TRIM(LTRIM(STR(nMajor)) + '.' + LTRIM(STR(nMinor)) + cVersion)
CASE nType == 1
   // 1 = Date stamp of release as a DATE type ( "03/30/98" )
   xReturn := dDate
CASE nType == 2
   // 2 = Time stamp of release as a string ( "5:20a" )
   xReturn := cTime
CASE nType == 3
   //  3 = A string containing the following information:
   //      product name, dialect, version number, date stamp, and
   //      time stamp.  (For example: "Advantage RDD for CA-Clipper 5.2, CDX/IDX, 5.0, 03/30/98, 5:20a")
   xReturn := cDescription + SPACE(1) + TRIM(LTRIM(STR(nMajor)) + '.' + LTRIM(STR(nMinor)) + cVersion) + ', ' + DTOC(dDate) + SPACE(1) + cTime
   // Append Alaska ADSDBE Version info too CRLF delimeter
   xReturn += CHR(13) + CHR(10) + DbeInfo( COMPONENT_DATA, DBE_NAME ) + PADC('=',3) + DbeInfo( COMPONENT_DATA, DBE_VERSION ) + SPACE(1) + DbeInfo( COMPONENT_DATA, DBE_MANUFACTURER )
ENDCASE

RETURN xReturn

* ------------------

FUNCTION aofFilterInfo( )  // Contributed by Mark Butler

// Get information about a Client Advantage Optimized Filter
/*   From the Advantage Norton Guide:
     A single dimensional array containing information about the
     specified user-owned filter or the system-owned filter.

Description
     aofFilterInfo() returns a seven element array with information about
     a Client Advantage Optimized Filter.  The first element of the array
     contains the entire filter expression.  The second element contains
     the non-optimized part of the filter expression, if applicable.  The
     third element contains the optimization level of the filter:
     0 = not optimized, 1 = partially optimized, and 2 = fully optimized.
     The fourth element is the number of records that are in the filter.
     The fifth element is the maximum record number possible in the
     filter.  The sixth element is the filter's owner: 1 = system-owned
     filter, 2 = user-owned filter. The seventh element is the current
     record number positioned to in the filter.

     Note:  Use the following constants defined in AOF.CH to reference
     the elements of the info array:
     #define INFO_EXPR        1  // Complete filter expression
     #define INFO_NONEXPR     2  // Non-optimized part of the expression
     #define INFO_OPTLVL      3  // Optimization level: 0=None, 1=Partial, 2=Full
     #define INFO_COUNT       4  // Number of records in filter
     #define INFO_SIZE        5  // Maximum record number possible in the filter
     #define INFO_OWNER       6  // Filter Owner, 1=System, 2=User
     #define INFO_POS         7  // Current record positioned to in the filter
*/

LOCAL aReturn := {'','',0,0,0,0,0},nLength := 500,cBuffer := SPACE(nLength),n := 0,;
      nTableHandle := 0,nIndexHandle := 0

IF Empty(Alias()) .OR. OrdNumber() = 0
   RETURN aReturn
ENDIF
nTableHandle := _GetTableHandle()
AdsGetIndexHandleByOrder( nTableHandle, OrdNumber(), @nIndexHandle )
AdsGetAOF(nTableHandle,@cBuffer, @nLength )
aReturn[1] := SUBSTR(cBuffer,1,nLength) // Complete filter expression
n := 0; nLength := 500; cBuffer := SPACE(nLength); AdsGetAOFOptLevel(nTableHandle, @n, @cBuffer, @nLength )
aReturn[2] := SUBSTR(cBuffer,1,nLength) // Non-optimized part of the expression
aReturn[3] := ABS(n - 3)    // adjust Optimization level for compatability: 0=None, 1=Partial, 2=Full
n := 0; AdsGetKeyCount(nIndexHandle, 1, @n) // get count and respect filters
aReturn[4] := n             // Number of records in filter
aReturn[5] := LASTREC()     // Maximum record number possible in the filter
aReturn[6] := 1             // ?? Filter Owner, 1=System, 2=User
n := 0; AdsGetKeyNum(nIndexHandle, 1, @n)
aReturn[7] := n             // Current record positioned to in the filter

RETURN aReturn

* -----------------

FUNCTION DC_AdsSkipper( nCursorHandle, nWantSkip, lAppend )

LOCAL nDidSkip := 0, nRecCount := 0, nEof := 0, nBof := 0

AdsGetRecordCount( nCursorHandle, ADS_IGNOREFILTERS, @nRecCount )
AdsAtEof( nCursorHandle, @nEof)

IF PCount() < 3
  lAppend := .F.
ENDIF

DO CASE

   CASE nRecCount == 0
   CASE nWantSkip == 0
      AdsSkip(nCursorHandle,0)

   CASE nWantSkip > 0 .AND. nEof == 0

      /* Skip down */
      DO WHILE nDidSkip < nWantSkip
         AdsSkip(nCursorHandle,1)
         AdsAtEof( nCursorHandle, @nEof)
         IF nEof == 1
            IF lAppend
               /* Append Mode: Ghost record */
               nDidSkip ++
            ELSE
              AdsSkip(nCursorHandle,-1)
            ENDIF
            EXIT
         ENDIF
         nDidSkip ++
      ENDDO

   CASE nWantSkip < 0

      /* Skip up */
      DO WHILE nDidSkip > nWantSkip
         AdsSkip(nCursorHandle,-1)
         AdsAtBof( nCursorHandle, @nBof)
         IF nBof == 1
            EXIT
         ENDIF
         nDidSkip --
      ENDDO

   ENDCASE

RETURN  nDidSkip

* ------------------

FUNCTION DC_AdsGoPosition( nCursor, nPosition )

LOCAL nRecCount := 0, nRecNo
nPosition := nPosition / 100

AdsGetRecordCount( nCursor, ADS_IGNOREFILTERS, @nRecCount )
nRecNo := Int( nRecCount * nPosition )
IF nRecNo <= 0
  nRecNo := 1
ENDIF
AdsGotoRecord(nCursor,nRecNo)

RETURN nil

* ------------------

FUNCTION DC_AdsPosition( nCursor )

LOCAL nRecNo := 0, nRecCount := 0, nPosition

AdsGetRecordCount( nCursor, ADS_IGNOREFILTERS, @nRecCount )
AdsGetRecordNum(nCursor,ADS_IGNOREFILTERS,@nRecNo)

nPosition := Int(( nRecNo / nRecCount ) * 100)
IF nPosition < 1
  nPosition := 1
ENDIF

RETURN nPosition

* ------------------

FUNCTION DC_AdsFieldBlock( nCursor, cFieldName, bFormat )

LOCAL cBlock, bBlock, nFieldPos, nFieldLen, nFieldDec, nFieldType, cGet, cSet

/*
nFieldPos := 1
AdsGetFieldNum( nCursor, cFieldName, @nFieldPos )
*/

//dcbdebug nCursor, cFieldName, @nFieldType

nFieldType := 0
nFieldDec := 0

AdsGetFieldType( nCursor, cFieldName, @nFieldType )

IF nFieldType = ADS_LOGICAL
  nFieldLen := 1
ELSEIF nFieldType = ADS_DATE
  nFieldLen := 10
ELSE
  nFieldLen := 0
  AdsGetFieldLength( nCursor, cFieldName, @nFieldLen )
ENDIF

AdsGetFieldDecimals( nCursor, cFieldName, @nFieldDec )

IF nFieldPos <> 0

   cGet := '(AdsGetField(' + Alltrim(Str(nCursor)) + ;
           ',"' + ;
           cFieldName + ;
           '",@a,b),a:=Pad(a,b)'

   IF nFieldType = ADS_LOGICAL
     cGet += ',a:=(a[1]$"TY")'
   ELSEIF nFieldType == ADS_DATE
     cGet += ',a:=CtoD(a)'
   ELSEIF nFieldType == ADS_NUMERIC .OR. nFieldType == ADS_DOUBLE .OR. nFieldType == ADS_INTEGER .OR. ;
          nFieldType == ADS_SHORTINT
     cGet += ',a:=Val(a)'
   ENDIF
   IF Valtype(bFormat) = 'B'
     cGet += ',Eval(' + DC_XtoC(bFormat) + ',a)'
   ENDIF

   cGet += ')'

   cSet := '(_AdsSetField(' + Alltrim(Str(nCursor)) + ;
           ',"' + ;
           cFieldName + ;
           '",x,b,' + Alltrim(Str(nFieldDec)) + '))'

   cBlock := '{|x,a,b|' + ;
             'a:=Space('+Alltrim(Str(nFieldLen)) + ;
             '),b:=' + Alltrim(Str(nFieldLen)) + ',' + ;
             cGet + ',IIF(x==nil .OR. x==a, a,' + cSet + ')'

   cBlock += '}'
   bBlock := &(cBlock)

ENDIF

RETURN bBlock

* ------------

FUNCTION _AdsSetField( nHandle, cFieldName, xValue, nLength, nDec )

LOCAL nError, cErrorString, nErrorLen

IF Valtype(xValue) = 'N'
  xValue := Str(xValue,nLength,nDec)
ELSEIF Valtype(xValue) = 'D'
  xValue := DC_XtoC(xValue)
ELSEIF Valtype(xValue) = 'L'
  xValue := IIF(xValue,'Y','N')
ENDIF

nError := AdsSetField( nHandle, cFieldName, xValue, nLength )

cErrorString := Space(250)
nErrorLen := 250
nError := 0
AdsGetLastError(@nError,@cErrorString,@nErrorLen)
cErrorString := Strtran(Pad(cErrorString,nErrorLen),';',Chr(13))

IF nError > 0
  DC_WinAlert(cErrorString,,,,,DC_AdsSqlQueryWindow())
ENDIF

RETURN nError

* ------------------

FUNCTION DC_AdsSQLQuery( cServer, cUserName, cPassword, cDataPath, oParent, ;
                         nIndexMode, nLockingMode, cViewDbe, cStatement, lExit, ;
                         lAlways )

LOCAL nHandle := 0, oStatic, oToolBar, GetList[0], ;
      cDescription, GetOptions, oDesc, oBrowseDesc, oStatic1, oStatic2, ;
      aBrowPres, aStru, oBrowse, oExecuteButton, lStatus

DEFAULT cViewDbe := 'DBFNTX', ;
        cStatement := '', ;
        lExit := .f., ;
        lAlways := .f.

DEFAULT cDataPath := DC_Path(AppName(.t.)), ;
        nIndexMode := DC_AdsIndexModeDefault(), ;
        nLockingMode := DC_AdsLockModeDefault(), ;
        cDescription := '<passed in>'

IF Empty(cStatement)
  IF !File(cDataPath + '\ADSSQL.DBF')
    aStru := { ;
       { 'DESC',   'C', 70, 0 }, ;
       { 'STATEMENT', 'C', 3000, 0} }
    dbCreate( cDataPath + '\ADSSQL.DBF', aStru, cViewDbe )
  ENDIF

  IF Select('ADSSQL') = 0
    USE ( cDataPath + '\ADSSQL')  VIA (cViewDbe) NEW SHARED
  ENDIF
ENDIF

DEFAULT cServer := '', ;
        cUserName := '', ;
        cPassword := ''

IF Empty(cServer)
  cServer := cDataPath
ENDIF

/*
IF Empty(cStatement)
  cDescription := Pad(ADSSQL->desc,70)
  cStatement := Alltrim(ADSSQL->statement)
ENDIF
*/

cUserName := Pad(cUserName,50)
cPassword := Pad(cPassword,50)
cServer := Pad(cServer,100)

@ 0,30 DCSAY DC_LangMsg(DCMSG_PATH) + '/' + DC_LangMsg(DCMSG_DICTIONARY) GET cServer GETSIZE 30 SAYSIZE 0 SAYBOTTOM ;
       POPUP {|c|DC_PopFile(c)}

@ DCGUI_ROW, DCGUI_COL + 20 DCSAY DC_LangMsg(DCMSG_USER) GET cUserName SAYSIZE 0 SAYBOTTOM GETSIZE 10
@ DCGUI_ROW, DCGUI_COL + 20 DCSAY DC_LangMsg(DCMSG_PASSWORD) GET cPassword SAYSIZE 0 SAYBOTTOM GETSIZE 10

@ 1,30 DCSAY DC_LangMsg(DCMSG_STATEMENT) + ' ' + DC_LangMsg(DCMSG_DESCRIPTION) ;
      GET cDescription SAYSIZE 0 SAYBOTTOM ;
      WHEN {||DC_DbSel('ADSSQL') .AND. !ADSSQL->(Deleted())} GETOBJECT oDesc GETSIZE 40 ;

@ 2, 30 DCSTATIC TYPE XBPSTATIC_TYPE_TEXT SIZE 38,1 OBJECT oStatic1
@ 0, 0 DCSAY 'Index Mode:' SAYSIZE 0 SAYBOTTOM PARENT oStatic1
@ DCGUI_ROW, DCGUI_COL + 10 DCRADIO nIndexMode VALUE ADS_NTX PROMPT 'DBFNTX' PARENT oStatic1
@ DCGUI_ROW, DCGUI_COL + 10 DCRADIO nIndexMode VALUE ADS_CDX PROMPT 'DBFCDX' PARENT oStatic1

@ 2, 70 DCSTATIC TYPE XBPSTATIC_TYPE_TEXT SIZE 38,1 OBJECT oStatic2
@ 0, 0 DCSAY 'Locking Mode:' SAYSIZE 0 SAYBOTTOM PARENT oStatic2
@ DCGUI_ROW, DCGUI_COL + 10 DCRADIO nLockingMode VALUE 0 PROMPT 'Compatible' PARENT oStatic2
@ DCGUI_ROW, DCGUI_COL + 10 DCRADIO nLockingMode VALUE 1 PROMPT 'Proprietary' PARENT oStatic2

@ 3.3,30 DCMULTILINE cStatement SIZE 85,7.2 FONT '10.Courier' ;
      WHEN {||!DC_DbSel('ADSSQL') .OR. !ADSSQL->(Deleted())} ;
      RESIZE { DCGUI_REPOSY_BLOCK,DCGUI_RESIZEX_BLOCK}

IF Empty(cStatement)

  @ 0,0 DCBROWSE oBrowseDesc ALIAS 'ADSSQL' SIZE 29,10.4 ;
      PRESENTATION DC_BrowPres() ;
      NOHSCROLL ;
      RESIZE DCGUI_RESIZE_REPOSONLY_Y ;
      ITEMMARKED {||cDescription := ADSSQL->desc, ;
                    cStatement := ADSSQL->statement, ;
                    DC_GetRefresh(GetList,,DCGETREFRESH_TYPE_EXCLUDE,{GETLIST_BROWSE}) }

  DCBROWSECOL DATA {||IIF(ADSSQL->(Deleted()),'*Del* ','') + ADSSQL->desc} ;
       HEADER 'Description' WIDTH 20 PARENT oBrowseDesc DATATOOLTIP {||.t.}
ENDIF

@ 10.6, 0 DCTOOLBAR oToolBar SIZE 110,1.2 BUTTONSIZE 10,1.2

@ 11.9, 0 DCSAY DC_LangMsg(DCMSG_RESULTS) OBJECT oStatic ;
          SIZE 115,17 COLOR GRA_CLR_BLACK, GRA_CLR_WHITE ;
          SAYOPTION XBPALIGN_HCENTER + XBPALIGN_VCENTER + XBPALIGN_WORDBREAK ;
          RESIZE DCGUI_RESIZE_RESIZEONLY

DCADDBUTTON CAPTION DC_LangMsg(DCMSG_EXECUTE) ;
   OBJECT oExecuteButton ;
   ACTION {||lStatus := DC_ExecuteSQL(cServer,cStatement,oStatic,@nHandle,@oBrowse,cUserName, ;
                                      cPassword,GetList,nIndexMode,nLockingMode), ;
             DC_GetWhen(GetList), ;
             IIF( (lStatus .OR. lAlways) .AND. lExit, DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList),nil)} ;
   PARENT oToolBar

DCADDBUTTON CAPTION DC_LangMsg(DCMSG_SAVE) ACTION {||SaveStatement( cDescription, cStatement, GetList )} ;
   PARENT oToolBar

DCADDBUTTON CAPTION DC_LangMsg(DCMSG_NEW) ACTION {||NewStatement( @cDescription, @cStatement, GetList ), ;
                                    SetAppFocus(oDesc)} ;
   PARENT oToolBar

DCADDBUTTON CAPTION {||IIF(DC_DbSel('ADSSQL') .AND. ADSSQL->(Deleted()),DC_LangMsg(DCMSG_DBU_RECALL),DC_LangMsg(DCMSG_DBU_DELETE))} ;
   ACTION {||DeleteStatement(@cDescription,@cStatement,GetList)} ;
   PARENT oToolBar

DCADDBUTTON CAPTION DC_LangMsg(DCMSG_PRINT) ACTION {||PrintResult(@cDescription,@cStatement,oBrowse,GetList)} ;
   PARENT oToolBar ;
   WHEN {||Valtype(oBrowse)=='O'}

DCADDBUTTON CAPTION 'Excel' ;
   TOOLTIP 'Export Results to an Excel worksheet' ;
   ACTION {||DC_AdsCursor2Excel(oBrowse:dataSource),oBrowse:refreshAll()} ;
   PARENT oToolBar ;
   WHEN {||Valtype(oBrowse)=='O'}

DCADDBUTTON CAPTION DC_LangMsg(DCMSG_CREATE) + ' ' + DC_LangMsg(DCMSG_DICTIONARY) SIZE 14 ;
   ACTION {||cServer := Pad(DC_AdsDDCreate(),100), ;
             DC_GetRefresh(GetList)} ;
   ACCELKEY xbeK_ALT_T ;
   PARENT oToolBar

DCADDBUTTON CAPTION DC_LangMsg(DCMSG_EXIT) ACTION {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)} ;
   PARENT oToolBar

DCGETOPTIONS ;
   RESIZE ;
   RESIZEDEFAULT DCGUI_RESIZE_REPOSONLY_Y ;
   TABSTOP ;
   _PIXEL .f.

DCREAD GUI ;
   FIT ;
   OPTIONS GetOptions ;
   TITLE DC_LangMsg(DCMSG_SQL_ENTER_STATEMENT) ;
   NOAUTORESTORE ;
   APPWINDOW oParent ;
   EVAL {|o|DC_AdsSqlQueryWindow(o), ;
           IIF(!Empty(cStatement),PostAppevent(xbeP_Activate,,,oExecuteButton),nil)}

IF DC_DbSel('ADSSQL')
  ADSSQL->(dbCloseArea())
ENDIF

IF !Empty(nHandle) .AND. Empty(oParent)
  AdsDisconnect(nHandle)
ENDIF

RETURN lStatus

* -----------

FUNCTION DC_AdsSqlQueryWindow( oWindow )

STATIC soWindow := nil

LOCAL oOldWindow := soWindow

IF Valtype(oWindow) == 'O'
  soWindow := oWindow
ENDIF

RETURN oOldWindow

* -----------

FUNCTION DC_ExecuteSQL( ncServer, cSelect, oStatic, nHandle, oBrowse, cUserName, ;
                        cPassword, aGetList, nIndexMode, nLockingMode, cErrorString, ;
                        lShowBrowseWindow, nStatementHandle, aArray, nCursorHandle )

LOCAL GetList[0], lDisconnect := .f., ;
      nNumFields, bDataSource, bFormat, cFieldName, i, nVerify, ;
      lStatus, nLength, nError, nErrorLen

DEFAULT nIndexMode := ADS_CDX, ;
        nLockingMode := ADS_COMPATIBLE_LOCKING, ;
        lShowBrowseWindow := .T.

IF Valtype(oBrowse) = 'O'
  DC_GetDestroy(aGetList,'BROWSE')
  oBrowse := nil
ENDIF

IF Valtype(oStatic) == 'O'
  oStatic:setCaption('Executing SQL Statement. Please wait...')
ENDIF

IF Valtype(nHandle) = 'N' .AND. nHandle > 0
  AdsDisconnect(nHandle)
ENDIF

IF Valtype(ncServer) == 'C'
  nHandle := 0
  ncServer := Alltrim(ncServer)
  IF '.ADD' $ Upper(ncServer)
    AdsConnect60( ncServer, ;
                ADS_REMOTE_SERVER + ADS_LOCAL_SERVER, ;
                Alltrim(cUserName), ;
                Alltrim(cPassword), ;
                ADS_DEFAULT, ;
                @nHandle )
  ELSE
    AdsSetServerType( ADS_REMOTE_SERVER + ADS_LOCAL_SERVER )
    AdsConnect( ncServer, @nHandle )
  ENDIF

  IF nHandle = 0
    cErrorString := DC_AdsGetLastError()
    IF Valtype(oStatic) = 'O'
      oStatic:setCaption(cErrorString)
    ENDIF
    RETURN .F.
  ENDIF
  lDisconnect := .t.
ELSE
  nHandle := ncServer
ENDIF

nStatementHandle := 0
AdsCreateSQLStatement( nHandle, @nStatementHandle )

AdsStmtSetTableType( nStatementHandle, nIndexMode )
AdsStmtSetTableLockType( nStatementHandle, nLockingMode )

nVerify := AdsVerifySQL( nStatementHandle, cSelect )

IF nVerify > 0
  cErrorString := DC_AdsGetLastError()
  IF Valtype(oStatic) = 'O'
    oStatic:setCaption(cErrorString)
  ENDIF
  IF lDisconnect
    AdsDisconnect(nHandle)
  ENDIF
  RETURN .F.
ENDIF

nCursorHandle := 0
AdsExecuteSQLDirect( nStatementHandle, cSelect, @nCursorHandle )

IF nCursorHandle = 0
  cErrorString := DC_AdsGetLastError()
  IF Valtype(oStatic) = 'O'
    oStatic:setCaption(cErrorString)
  ENDIF
  IF lDisconnect
    AdsDisconnect(nHandle)
  ENDIF
  RETURN .F.
ENDIF

IF !lShowBrowseWindow
  nHandle := nCursorHandle
  RETURN .T.
ENDIF

nNumFields := 0
AdsGetNumFields( nCursorHandle, @nNumFields )

IF nNumFields = 0
  IF Valtype(oStatic) = 'O'
    oStatic:setCaption('Sorry. No fields to browse!')
  ENDIF
  IF lDisconnect
    AdsDisconnect(nHandle)
  ENDIF
  RETURN .F.
ENDIF

IF Valtype(oStatic) # 'O'
  RETURN .t.
ENDIF

bDataSource := {||nCursorHandle}
@ 0,0 DCBROWSE oBrowse ;
      PIXEL ;
      GROUP 'BROWSE' ;
      RESIZE DCGUI_RESIZE_RESIZEONLY ;
      AUTOREFRESH 3000 ;
      DATA bDataSource ;
      EDIT xbeBRW_ItemSelected ;
      SIZE oStatic:currentSize()[1], oStatic:currentSize()[2] ;
      PRESENTATION DC_BrowPres()

FOR i := 1 TO nNumFields

  cFieldName := Space(20)
  nLength := 20
  AdsGetFieldName( nCursorHandle, i, @cFieldName, @nLength )
  cFieldName := Pad(cFieldName,nLength)

  DCBROWSECOL ADSFIELD cFieldName CURSOR nCursorHandle ;
    PARENT oBrowse HEADER cFieldName GROUP 'BROWSE'

NEXT

oStatic:hide()

DCREAD GUI ;
   PARENT oStatic ;
   EXIT ;
   _SAVE .T.

DC_MergeGetLists(aGetList,GetList)
oStatic:show()

RETURN .T.

* -------------

STATIC FUNCTION NewStatement( cDescription, cStatement, GetList )

IF ADSSQL->(DC_AddRec(5))
  REPL ADSSQL->desc WITH '<New Description>'
  ADSSQL->(dbUnlock())
ENDIF
cDescription := ADSSQL->desc
cStatement := Alltrim(ADSSQL->statement)
DC_GetRefresh(GetList)

RETURN .T.

* -------------

STATIC FUNCTION SaveStatement( cDescription, cStatement, GetList )

IF !ADSSQL->(DC_RecLock())
  RETURN .F.
ENDIF
REPL ADSSQL->desc WITH cDescription
REPL ADSSQL->statement WITH cStatement
ADSSQL->(dbUnlock())
DC_GetRefresh(GetList)

RETURN .T.

* -------------

STATIC FUNCTION DeleteStatement( cDescription, cStatement, GetList )

LOCAL lStatus, nSaveRec

DCMSGBOX 'Are you sure?' YESNO TO lStatus
IF !lStatus
  RETURN .F.
ENDIF

nSaveRec := ADSSQL->(RecNo())
IF ADSSQL->(DC_RecLock())
  IF !ADSSQL->(Deleted())
    ADSSQL->(dbDelete())
    IF Set(_SET_DELETED)
      ADSSQL->(dbSkip(-1))
    ENDIF
  ELSE
    ADSSQL->(dbRecall())
  ENDIF
  ADSSQL->(dbUnlock())
ENDIF

cDescription := ADSSQL->desc
cStatement := Alltrim(ADSSQL->statement)
DC_GetRefresh(GetList)

RETURN .T.

* ----------

STATIC FUNCTION PrintResult( cDescription, cStatement, oBrowse )

LOCAL aOptions

DCPRINT OPTIONS PREVIEW ORIENTATION 2 TO aOptions
DC_PrintBrowse( oBrowse, aOptions,,,, Alltrim(cDescription) )

RETURN nil

* -----------

FUNCTION DC_AdsDDCreate()

LOCAL GetList[0], GetOptions, cFileName, cFileDesc, aList[0], aFiles[0], ;
      cFilePath, oPickList, cSavePath := '', cUser, cPassword

cFileName := Space(200)
cFileDesc := Space(200)
cFilePath := Space(200)
cUser := Space(50)
cPassword := Space(50)

@ 0,0 DCSAY DC_LangMsg(DCMSG_SQL_DICT_CREATE) + ':'
@ 1,0 DCGET cFileName GETSIZE 80 ;
      POPUP {|c|DC_PopFile(c)} ;
      VALID {||cFilePath := Pad(DC_Path(cFileName),200), ;
               cSavePath := Alltrim(cFilePath), ;
               LoadFiles( cFilePath, aList, aFiles ), ;
               DC_VarToListBox(oPickList), ;
               DC_GetRefresh(GetList), ;
               !Empty(cFileName)}

@ 2,0 DCSAY DC_LangMsg(DCMSG_DICTIONARY) + ' ' + DC_LangMsg(DCMSG_DESCRIPTION) + ':'
@ 3,0 DCGET cFileDesc GETSIZE 80

@ 4,0 DCSAY DC_LangMsg(DCMSG_SQL_DATA_PATH) + ':'
@ 5,0 DCGET cFilepath GETSIZE 80 POPUP {|c|DC_PopDir(c)} ;
      VALID {||IIF(!(cSavePath==Alltrim(cFilePath)),LoadFiles(cFilePath,aList,aFiles),nil), ;
               DC_VarToListBox(oPicklist), ;
               cSavePath := Alltrim(cFilePath), ;
               IIF(!Empty(aList),.t.,(DC_WinAlert('No Files in Chosen Directory'),.f.))}

@ 6.4,0 DCSAY DC_LangMsg(DCMSG_USER) GET cUser GETSIZE 30
@ DCGUI_ROW, DCGUI_COL + 20 DCSAY DC_LangMsg(DCMSG_PASSWORD) GET cPassword GETSIZE 30

@ 8,0 DCPICKLIST aFiles LIST aList SIZE 80,15 ;
      IMMEDIATE ;
      OBJECT oPickList ;
      CAPTION DC_LangMsg(DCMSG_SQL_AVAIL_FILES), DC_LangMsg(DCMSG_SQL_SEL_FILES)

@ 24, 0 DCPUSHBUTTON CAPTION DC_LangMsg(DCMSG_CREATE) + ' ' + DC_LangMsg(DCMSG_DICTIONARY) SIZE 15,1.2 ;
      ACTION {||CreateDictionary( cFileName, cFileDesc, cFilePath, aFiles, cUser, cPassword )} ;
      WHEN {||!Empty(cFileName) .AND. !Empty(cFileDesc) .AND. !Empty(cFilePath) .AND. !Empty(aFiles)}

@ DCGUI_ROW, DCGUI_COL + 20 DCPUSHBUTTON CAPTION DC_LangMsg(DCMSG_EXIT) SIZE 15,1.2 ;
      ACTION {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)} CARGO 'CANCEL'

DCGETOPTIONS ;
   TABSTOP ;
   SAYWIDTH 0 ;
   SAYBOTTOM ;
   _PIXEL .f.

DCREAD GUI ;
   FIT ;
   NOAUTORESTORE ;
   MODAL ;
   OPTIONS GetOptions ;
   TITLE DC_LangMsg(DCMSG_SQL_CREATE_ADS)

RETURN Alltrim(cFileName)

* ---------------

STATIC FUNCTION LoadFiles( cFilePath, aList, aFiles, oPick )

LOCAL aDir, i

ASize(aList,0)
ASize(aFiles,0)
cFilePath := DC_Path(Alltrim(cFilePath)) + '*.DBF'
aDir := Directory(cFilePath)
FOR i := 1 TO Len(aDir)
  AAdd(aList,aDir[i,1])
NEXT

ASort(aList)

RETURN nil

* --------------

STATIC FUNCTION CreateDictionary( cFileName, cFileDesc, cFilePath, aFiles, cUserName, cPassword )

LOCAL nHandle := 0, cErrorString, nError, nErrorLen, lStatus, cTableName, i, ;
      cIndexes, cComments, cFile

AdsSetServerType( ADS_REMOTE_SERVER + ADS_LOCAL_SERVER )

cFile := DC_Path(Alltrim(cFileName),.t.)
DCMSGBOX 'Create Dictionary file: ' + cFile + ' ?' YESNO ;
   TO lStatus

IF !lStatus
  RETURN .f.
ENDIF


IF File(Alltrim(cFileName))

  DCMSGBOX Alltrim(cFileName), 'Dictionary file already exists.', ;
     'Add tables to existing file?' YESNO TO lStatus

  IF !lStatus
    RETURN .F.
  ENDIF

  nError := AdsConnect60( Alltrim(cFileName), ;
                ADS_REMOTE_SERVER + ADS_LOCAL_SERVER, ;
                Alltrim(cUserName), ;
                Alltrim(cPassword), ;
                ADS_DEFAULT, ;
                @nHandle )

ELSE

  nError := AdsDDCreate( Alltrim(cFileName), .F., Alltrim(cFileDesc), @nHandle )
  IF nError == 0 .AND. !Empty(cUserName)
    AdsDDCreateUser( nHandle, '', cUserName, cPassword, 'Administrative User' )
  ENDIF

Endif

IF nHandle <= 0 .OR. nError > 0
  cErrorString := DC_AdsGetLastError()
  IF !Empty(cErrorString)
    DC_WinAlert(cErrorString,,,,,DC_AdsSqlQueryWindow())
  ENDIF
  RETURN .F.
ENDIF

cFilePath := Trim(cFilePath)
IF !Right(cFilePath,1) == '\'
  cFilePath += '\'
ENDIF

FOR i := 1 TO Len(aFiles)
  cTableName := aFiles[i]
  cIndexes := ''
  cComments := ''
  nError := AdsDDAddTable( nHandle, cTableName, cFilePath+cTableName, ADS_CDX, ADS_OEM, '', '' )
  IF nError > 0
    cErrorString := DC_AdsGetLastError()
    DCMSGBOX cErrorString, 'Continue Adding Files?' YESNO TO lStatus
    IF !lStatus
      EXIT
    ENDIF
  ENDIF
NEXT

AdsDisconnect(nHandle)

IF nError == 0
  DCMSGBOX 'Done!' TIMEOUT 2
ENDIF

RETURN .T.

* ------------------

FUNCTION DC_FieldGet( nFieldPos, xDataSource )

LOCAL nFieldLen, nFieldDec, nFieldType, cValue, xValue, ;
      cFieldName, nLength, cDataType := Valtype(xDataSource)

IF nFieldPos == nil

  xValue := nil

ELSEIF xDataSource == NIL

  IF Valtype(nFieldPos) == 'C' // It's a field name
    nFieldPos := FieldPos(cFieldName)
  ENDIF
  xValue := FieldGet(nFieldPos)

ELSEIF cDataType == 'C'  // It's an alias

  IF Valtype(nFieldPos) == 'C' // It's a field name
    nFieldPos := (xDataSource)->(FieldPos(nFieldPos))
  ENDIF
  xValue := (xDataSource)->(FieldGet(nFieldPos))

ELSEIF cDataType == 'O' // It's an SQLexpress cursor

  xValue := xDataSource:fieldGet(nFieldPos)

ELSEIF cDataType == 'N'  // It's an ADS SQL Cursor

  nFieldType := 0
  nFieldDec := 0

  IF Valtype(nFieldPos) == 'C'
    cFieldName := nFieldPos
    nFieldPos := 0
    AdsGetFieldNum( xDataSource, cFieldName, @nFieldPos )
  ELSE
    cFieldName := Space(20)
    nLength := 20
    AdsGetFieldName( xDataSource, nFieldPos, @cFieldName, @nLength )
    cFieldName := Trim(cFieldName)
  ENDIF

  AdsGetFieldType( xDataSource, cFieldName, @nFieldType )

  IF nFieldType = ADS_LOGICAL
    nFieldLen := 1
  ELSEIF nFieldType = ADS_DATE
    nFieldLen := 10
  ELSE
    nFieldLen := 0
    AdsGetFieldLength( xDataSource, cFieldName, @nFieldLen )
  ENDIF

  AdsGetFieldDecimals( xDataSource, cFieldName, @nFieldDec )

  IF nFieldPos <> 0

    cValue := Space(nFieldLen)
    AdsGetField( xDataSource, cFieldName, @cValue, @nFieldLen )

    IF nFieldType = ADS_LOGICAL

      xValue := cValue $ "TY"

    ELSEIF nFieldType == ADS_DATE

      xValue := CtoD(cValue)

    ELSEIF nFieldType == ADS_NUMERIC .OR. ;
          nFieldType == ADS_DOUBLE .OR. ;
          nFieldType == ADS_INTEGER .OR. ;
          nFieldType == ADS_SHORTINT

      xValue := Val(cValue)

    ELSE

      xValue := cValue

    ENDIF

  ENDIF

ENDIF

RETURN xValue

* ------------------

FUNCTION DC_FieldPut( nFieldPos, xValue, xDataSource )

LOCAL nFieldLen, nFieldDec, nFieldType, cValue, cFieldName, nLength, ;
      xReturn, nError, cDataType := Valtype(xDataSource)

IF nFieldPos == NIL

  xReturn := .F.

ELSEIF xDataSource == NIL

  IF Valtype(nFieldPos) == 'C' // It's a field name
    nFieldPos := FieldPos(cFieldName)
  ENDIF
  xReturn := FieldPut( nFieldPos, xValue )

ELSEIF cDataType == 'C'  // It's an alias

  IF Valtype(nFieldPos) == 'C' // It's a field name
    nFieldPos := (xDataSource)->(FieldPos(cFieldName))
  ENDIF
  xValue := (xDataSource)->(FieldPut(nFieldPos,xValue))

ELSEIF cDataType == 'O' // It's an SQLexpress cursor

  xReturn := xDataSource:fieldPut(nFieldPos,xValue)

ELSEIF cDataType == 'N'  // It's an ADS SQL Cursor

  nFieldType := 0
  nFieldDec := 0

  IF Valtype(nFieldPos) == 'C'
    cFieldName := nFieldPos
    nFieldPos := 0
    AdsGetFieldNum( xDataSource, cFieldName, @nFieldPos )
  ELSE
    cFieldName := Space(20)
    nLength := 20
    AdsGetFieldName( xDataSource, nFieldPos, @cFieldName, @nLength )
    cFieldName := Trim(cFieldName)
  ENDIF

  AdsGetFieldType( xDataSource, cFieldName, @nFieldType )

  IF nFieldType = ADS_LOGICAL
    nFieldLen := 1
  ELSEIF nFieldType = ADS_DATE
    nFieldLen := 10
  ELSE
    nFieldLen := 0
    AdsGetFieldLength( xDataSource, cFieldName, @nFieldLen )
  ENDIF

  AdsGetFieldDecimals( xDataSource, cFieldName, @nFieldDec )

  IF nFieldPos <> 0

    IF Valtype(xValue) $ 'NIF'
      xValue := Str(xValue,nFieldLen,nFieldDec)
    ELSEIF Valtype(xValue) = 'D'
      xValue := DC_XtoC(xValue)
    ELSEIF Valtype(xValue) = 'L'
      xValue := IIF(xValue,'Y','N')
    ENDIF

    nError := AdsSetField( xDataSource, cFieldName, xValue, nFieldLen )

    xReturn := (nError == 0)

  ENDIF

ENDIF

RETURN xReturn

* --------------

FUNCTION DC_AdsGetLastError()

LOCAL nErrorLen, nError, cErrorString

cErrorString := Space(500)
nErrorLen := 500
nError := 0
AdsGetLastError(@nError,@cErrorString,@nErrorLen)
cErrorString := Strtran(Pad(cErrorString,nErrorLen),';',Chr(13))

RETURN cErrorString

* -------------

FUNCTION DC_AdsLockModeDefault( nLockMode )

LOCAL nOldLockMode, cDbe

STATIC snLockMode

IF snLockMode == nil
  IF 'ADSDBE' $ dbeList()
    cDbe := dbeSetDefault('ADSDBE')
    snLockMode := DbeInfo( COMPONENT_DATA, ADSDBE_LOCK_MODE )
    dbeSetDefault(cDbe)
  ELSE
    snLockMode := ADS_PROPRIETARY_LOCKING
  ENDIF
ENDIF

nOldLockMode := snLockMode

IF Valtype( nLockMode ) == 'N'
  snLockMode := nLockMode
ENDIF

RETURN nOldLockMode

* -------------

FUNCTION DC_AdsIndexModeDefault( nIndexMode )

LOCAL nOldIndexMode, cDbe

STATIC snIndexMode

IF snIndexMode == nil
  IF 'ADSDBE' $ dbeList()
    cDbe := DbeSetDefault('ADSDBE')
    snIndexMode := DbeInfo( COMPONENT_DATA, ADSDBE_TBL_MODE )
    dbeSetDefault(cDbe)
  ELSE
    snIndexMode := ADSDBE_CDX
  ENDIF
ENDIF

nOldIndexMode := snIndexMode

IF Valtype( nIndexMode ) == 'N'
  snIndexMode := nIndexMode
ENDIF

RETURN nOldIndexMode


* --------------

FUNCTION DC_AdsSessionDefault( oSession )

STATIC soSession

LOCAL oOldSession := soSession
IF Valtype(oSession) == 'O'
  soSession := oSession
ENDIF

RETURN oOldSession

* --------------

FUNCTION DC_AdsSessionDict( cDictionary )

LOCAL i, j, oSession, cConnect, aAdsSession

DEFAULT cDictionary := ''

IF Empty(cDictionary) .AND. Valtype(DC_AdsSessionDefault()) == 'O'
  RETURN DC_AdsSessionDefault()
ENDIF

cDictionary := Upper(Alltrim(cDictionary))
IF cDictionary == 'FREE'
ELSEIF !Right(cDictionary,4) == '.ADD'
  cDictionary += '.ADD'
ENDIF

aAdsSession := DC_AdsSession(,,.t.)
IF Valtype(aAdsSession) # 'A'
  RETURN nil
ENDIF

BEGIN SEQUENCE

FOR i := 1 TO Len(aAdsSession)
  IF i == ThreadID()
    FOR j := 1 TO Len(aAdsSession[i])
      oSession := aAdsSession[i,j]
      IF Valtype(oSession) == 'O' .AND. oSession:isConnected()
        cConnect := Upper(oSession:getConnectionString())
        IF 'ADSDBE' $ cConnect
          IF cDictionary == 'FREE' .AND. !('.ADD' $ cConnect)
            BREAK
          ELSEIF cDictionary $ cConnect
            BREAK
          ELSE
            oSession := nil
          ENDIF
        ELSE
          oSession := nil
        ENDIF
      ENDIF
    NEXT
  ENDIF
NEXT

END SEQUENCE

#if XPPVER > 1900000

BEGIN SEQUENCE

IF oSession == nil
  FOR j := 1 TO Len(aAdsSession[1])
    oSession := aAdsSession[1,j]
    IF Valtype(oSession) == 'O' .AND. oSession:isConnected()
      cConnect := Upper(oSession:getConnectionString())
      IF 'ADSDBE' $ cConnect
        BREAK
      ELSE
        oSession := nil
      ENDIF
    ENDIF
  NEXT
ENDIF
IF Valtype(oSession) == 'O'
  oSession := oSession:setDefault()
ENDIF

END SEQUENCE

#endif

RETURN oSession

* --------------

FUNCTION DC_AdsSession( xSession, nWhich, lReturnAll )

LOCAL cSession, nThread := ThreadID()

STATIC aAdsSession[0]

DEFAULT nWhich := 1, ;
        lReturnAll := .f.

IF Len(aAdsSession) < nThread
  ASize(aAdsSession,nThread)
  aAdsSession[nThread] := {}
ENDIF

IF Len(aAdsSession[nThread]) < nWhich
  ASize(aAdsSession[nThread],nWhich)
ENDIF

IF lReturnAll
  RETURN aAdsSession
ENDIF

IF Valtype(xSession) == 'C'
  IF Valtype(aAdsSession[nThread,nWhich]) # 'O' .OR. ;
            !aAdsSession[nThread,nWhich]:isConnected()
    cSession := "DBE=ADSDBE;SERVER=" + xSession
    aAdsSession[nThread,nWhich] := DacSession():new(cSession)
    IF !aAdsSession[nThread,nWhich]:isConnected()
      MsgBox( "Unable to establish connection to ADS Server" + Chr(13) + ;
              cSession + Chr(13) + ;
              "Error Code: " + Alltrim(Str(aAdsSession[nThread,nWhich]:getLastError())) + Chr(13) + ;
              aAdsSession[nThread,nWhich]:getLastMessage() )
    ELSEIF '.ADD' $ Upper(cSession)
      DC_AdsSessionDefault(aAdsSession[nThread,nWhich])
    ENDIF
  ENDIF
ELSEIF Valtype(xSession) == 'O'
  aAdsSession[nThread,nWhich] := xSession
ENDIF

RETURN aAdsSession[nThread,nWhich]

* -------------------

CLASS DC_AdsStatement

EXPORTED:
VAR Handle, Statement, Alias, Session, Cursor, LastError, CursorHandle, ;
    CursorOptions, isInsert, isUpdate, isDelete, isRead, lockingMode, ;
    indexMode, errorString

* -------------

INLINE METHOD GetLastError()
RETURN(::LastError)

* -------------

INLINE METHOD Init(cStatement, oSession, nLockingMode, nIndexMode )

LOCAL cMsg

DEFAULT nLockingMode := DC_AdsLockModeDefault(), ;
        nIndexMode := DC_AdsIndexModeDefault()

IF(ValType(oSession)!="O")

  cMsg := 'Parameter Type error : oSession' + Chr(13) + ;
          '(passed to DC_AdsStatement:Init())'

  Eval(DC_AdsMessageOutput(),cMsg)

  ::LastError := 3
  RETURN Self
ENDIF
IF(!oSession:IsDerivedFrom("DacSession"))
  cMsg := 'Parameter passed is not a DacSession : oSession' + chr(13) + ;
          '(passed to DC_AdsStatement:Init())'

  Eval(DC_AdsMessageOutput(),cMsg)

  ::LastError := 4
  ::errorString := cMsg
  RETURN Self
ENDIF
::Session := oSession
::CursorHandle := 0
::CursorOptions := 0
::isRead := .f.
::isUpdate := .f.
::isInsert := .f.
::isDelete := .f.
::lockingMode := nLockingMode
::indexMode := nIndexMode
RETURN ::Open(cStatement)

* ------------

INLINE METHOD Close()

IF(::HANDLE==NIL)
  RETURN(.F.)
ENDIF

// cursor still open
IF (Used(::Alias))
  (::Alias)->(DbCloseArea())
ENDIF

::LastError := AdsCloseTable(::CursorHandle)

// close statement
::LastError := AdsCloseSQLStatement(::HANDLE)

::Statement := NIL
::HANDLE    := NIL
::Alias     := NIL
RETURN .t.

* -------------

INLINE METHOD Open(cStatement)

LOCAL nH, nError, nErrorLen, cErrorString, cMsg

IF ValType(cStatement)!="C"
  cMsg := 'Parameter Type Invalid : Statement' + Chr(13) + ;
               '(passed to DC_AdsStatement:Open())'

  Eval(DC_AdsMessageOutput(),cMsg)

  ::LastError := 1
  RETURN self
ENDIF
IF(Upper(Left(Alltrim(cStatement),Len(KEYWORD_SELECT)))!=KEYWORD_SELECT)
  cMsg := 'Unsupported SQL statement:' + Chr(13) + cStatement + Chr(13)

  Eval(DC_AdsMessageOutput(),cMsg)

  ::LastError := 2
  RETURN self
ENDIF
::Statement := cStatement
nH := 0x0

::LastError := AdsCreateSQLStatement( ::Session:getConnectionHandle(), @nH )
::HANDLE := nH

IF ::LastError > 0
  cErrorString := DC_AdsGetLastError()
  ::errorString := cErrorString
  Eval(DC_AdsMessageOutput(),cErrorString)
ELSE
  IF Valtype(::lockingMode) == 'N'
    AdsStmtSetTableLockType( nH,::lockingMode )
  ENDIF
  IF Valtype(::indexMode) == 'N'
    AdsStmtSetTableType( nH, ::indexMode )
  ENDIF
  ::LastError := AdsVerifySQL( nH, cStatement )
  IF ::LastError > 0
    cErrorString := DC_AdsGetLastError()
    ::errorString := cErrorString
    Eval(DC_AdsMessageOutput(),cErrorString)
  ENDIF
ENDIF

RETURN self

* --------------

INLINE METHOD Execute( cAlias )

LOCAL rc := 0x0, nCursor := 0x0, cErrorString, nErrorLen, nError, n, cFile, ;
      lSaveAlias

::LastError := AdsExecuteSQLDirect( ::HANDLE , ::Statement , @nCursor )

IF ::LastError > 0
  cErrorString := DC_AdsGetLastError()
  ::errorString := cErrorString
  Eval(DC_AdsMessageOutput(),cErrorString)
  RETURN ''
ENDIF

n := 0
AdsGetTableType(nCursor,@n)

lSaveAlias := DbeInfo( COMPONENT_DATA, ADSDBE_TABLENAME_IS_ALIAS, .f. )
DbUseArea(TRUE,::Session,"<CURSOR>"+L2Bin(nCursor)+"</CURSOR>",cAlias)
DbeInfo( COMPONENT_DATA, ADSDBE_TABLENAME_IS_ALIAS, lSaveAlias )

IF (Used())
  ::Alias := Alias()
  ::Cursor := L2Bin(nCursor)
  ::CursorHandle  := nCursor
  AdsGetTableOpenOptions(nCursor,@::CursorOptions)
                                               // See DCADS.CH for these defines
  ::isRead := DC_BitTest(::cursorOptions,5)    // ADS_TABLE_PERM_READ
  ::isUpdate := DC_BitTest(::cursorOptions,6)  // ADS_TABLE_PERM_UPDATE
  ::isInsert := DC_BitTest(::cursorOptions,7)  // ADS_TABLE_PERM_INSERT
  ::isDelete := DC_BitTest(::cursorOptions,7)  // ADS_TABLE_PERM_DELETE

ENDIF

RETURN (::Alias)

ENDCLASS

* -------------

FUNCTION DC_AdsCursor2Excel( nCursorHandle, cExcelFile, nOrientation, ;
                             lDisplayAlerts, lVisible, lAutoFit )

LOCAL nNumFields := 0, i, cFieldName, nLength, lOk, ;
      aData[0], aFields[0], aColumn, nDidSkip, xValue, GetList[0]

IF Empty(cExcelFile)
  cExcelFile := Pad('worksheet.xls',60)

  @ 1,1 DCSAY DC_LangMsg(DCMSG_PC_OUTFILE) GET cExcelFile ;
      GETSIZE 50 SAYRIGHT

  DCREAD GUI EXPRESS FIT ADDBUTTONS TO lOk ENTEREXIT ;
      TITLE 'Excel File to Create' MODAL NOAUTORESTORE

  IF !lOk
    RETURN .f.
  ENDIF
ENDIF

aData := DC_AdsCursor2Array( nCursorHandle )

DC_Array2Excel( @cExcelFile, {aData}, nOrientation, ;
                lDisplayAlerts, lVisible, lAutoFit )

DC_SpawnUrl( cExcelFile )

RETURN nil

* --------------

FUNCTION DC_AdsCursor2Array( nCursorHandle )

LOCAL nNumFields := 0, i, cFieldName, nLength, lOk, ;
      aData[0], aFields[0], aColumn, nDidSkip, xValue, GetList[0]

AdsGoToTop(nCursorHandle)

nNumFields := 0
AdsGetNumFields( nCursorHandle, @nNumFields )

aColumn := Array(nNumFields)
FOR i := 1 TO nNumFields
  cFieldName := Space(20)
  nLength := 20
  AdsGetFieldName( nCursorHandle, i, @cFieldName, @nLength )
  cFieldName := Pad(cFieldName,nLength)
  AAdd( aFields, { cFieldName, ;
                   cFieldName, ;
                   nil, ;
                   DC_AdsFieldBlock( nCursorHandle, cFieldName ) })

  aColumn[i] := cFieldName
NEXT
AAdd(aData,aColumn)
nDidSkip := 1
DO WHILE .t.

  aColumn := Array(nNumFields)
  FOR i := 1 TO nNumFields
    xValue := Eval(aFields[i,4])
    aColumn[i] := xValue
  NEXT
  nDidSkip := DC_AdsSkipper(nCursorHandle,1)
  AAdd( aData, aColumn )
  IF nDidSkip == 0
    EXIT
  ENDIF

ENDDO

FOR i := 1 TO nNumFields
  ASize(aFields[i],3)
NEXT

AdsGoToTop(nCursorHandle)

RETURN aData

* --------------

FUNCTION DC_AdsRunSQL( cSqlStatement, cAlias )

LOCAL oDictConnection, oStatement

oDictConnection := DC_AdsSessionDict( '.ADD' )

IF Valtype(oDictConnection) # 'O'
  oDictConnection := DacSession():getDefault()
ENDIF

oStatement := DC_AdsStatement():New(cSqlStatement,oDictConnection)
IF oStatement:LastError > 0
  RETURN .f.
ENDIF

cAlias := oStatement:Execute( cAlias )

RETURN !Empty(cAlias)

* ------------

FUNCTION AdsSession( oSession )

STATIC soSession

LOCAL oOldSession

oOldSession := soSession

IF Valtype(oSession) == 'O'
  soSession := oSession
ENDIF

RETURN oOldSession

* ------------

FUNCTION AdsSessionDict( oSession )

STATIC soSession

LOCAL oOldSession

oOldSession := soSession

IF Valtype(oSession) == 'O'
  soSession := oSession
ENDIF

RETURN oOldSession

* ------------

FUNCTION AdsSessionFree( oSession )

STATIC soSession

LOCAL oOldSession

oOldSession := soSession

IF Valtype(oSession) == 'O'
  soSession := oSession
ENDIF

RETURN oOldSession

* -------------

FUNCTION DC_AdsGetSQLStatement()

LOCAL cDbfName, cCursor, nCursor, cBuffer, nLen, nHandle

IF Empty(Alias())
  RETURN ''
ENDIF

cDbfname := dbInfo( DBO_FILENAME )

IF Left(cDbfName,1) # '<'
  RETURN ''
ENDIF

cCursor := Substr(cDbfName,9,4)
nCursor := Bin2l(cCursor)

nHandle := 0
AdsGetSQLStatementHandle( nCursor, @nHandle )

cBuffer := Space(1000)
nLen := 1000

AdsGetSQLStatement( nHandle, @cBuffer, @nLen )

RETURN Substr(cBuffer,1,nLen)

* -----------

FUNCTION DC_AdsSqlStatement( cStatement, aArray, aObjects, cAlias, oSession, bEval )

LOCAL oStatement, lArray, lObjects, lEval, oRecord, aRecord

DEFAULT oSession := DacSession():getDefault()

oStatement := DC_AdsStatement():New(cStatement,oSession)

IF oStatement:LastError > 0
  RETURN oStatement
ENDIF

SELECT 0
cAlias := oStatement:Execute(cAlias)
IF oStatement:LastError > 0
  RETURN oStatement
ENDIF

lArray := Valtype(aArray) == 'A'
lObjects := Valtype(aObjects) == 'A'
lEval := Valtype(bEval) == 'B'

IF Valtype(aArray) = 'A' .OR. Valtype(aObjects) = 'A'
  DO WHILE !Eof()
    IF lArray .OR. lEval
      aRecord := Scatter()
    ENDIF
    IF lArray
      AAdd(aArray,aRecord)
    ENDIF
    IF lObjects
      oRecord := DC_DbRecord():new()
      DC_DbScatter(oRecord)
      AAdd(aObjects,oRecord)
    ENDIF
    IF lEval
      Eval(bEval,aRecord)
    ENDIF
    dbSkip()
  ENDDO
  dbGoTop()
ENDIF

IF Empty(cAlias)
  oStatement:close()
ENDIF

RETURN oStatement

* -------------

GETSETFUNCTION DC_AdsMessageOutput DEFAULT {|c|Msgbox(c)}

* -------------

FUNCTION DC_AdsTableList( oSession )

LOCAL i, cData, nLen, nHandle, nError, aObject[0], nDictHandle

DEFAULT oSession := DC_AdsSessionDict()

nDictHandle := oSession:getConnectionHandle()

cData := Space(ADS_DD_MAX_OBJECT_NAME_LEN)
nLen := ADS_DD_MAX_OBJECT_NAME_LEN
nHandle := 0
nError := AdsDDFindFirstObject( nDictHandle, ;
   ADS_DD_TABLE_OBJECT, ;
   '', ;
   @cData, ;
   @nLen, ;
   @nHandle )

IF nError == 0
   cData := Strtran(cData,Chr(0),'')
   AAdd( aObject, {Alltrim(cData),_TableProperties(Alltrim(cData),nDictHandle)})
ENDIF

DO WHILE nError == 0 .AND. nHandle > 0

   cData := Space(ADS_DD_MAX_OBJECT_NAME_LEN)
   nLen := ADS_DD_MAX_OBJECT_NAME_LEN
   nError := AdsDDFindNextObject( nDictHandle, ;
      nHandle, ;
      @cData, ;
      @nLen )

   IF nError == 0 .AND. !Empty(cData)
      cData := Alltrim(Strtran(cData,Chr(0),''))
      AAdd( aObject, { cData, _TableProperties(Alltrim(cData),nDictHandle)})
   ENDIF

ENDDO
AdsDDFindClose(nHandle)

RETURN aObject

* --------------

STATIC FUNCTION _TableProperties( cTableName, nDictHandle )

LOCAL aProperties, i, nProperty, xValue, nLen, nError, aData[0]

aProperties := { ;
   { ADS_DD_COMMENT, Space(200), 200, 'Comment' }, ;
   { ADS_DD_USER_DEFINED_PROP, Space(200), 200, 'User Defined Table Property'}, ;
   { ADS_DD_TABLE_VALIDATION_EXPR, Space(200), 200, 'Record Level Validation Expression'}, ;
   { ADS_DD_TABLE_VALIDATION_MSG, Space(200), 200, 'Table Validation Error Message'}, ;
   { ADS_DD_TABLE_PRIMARY_KEY, Space(200), 200, 'Table Primary Key'}, ;
   { ADS_DD_TABLE_TYPE, 2, 2, 'Type of Base Table'}, ;
   { ADS_DD_TABLE_FIELD_COUNT, 100, 100, 'Field Count'}, ;
   { ADS_DD_TABLE_ENCRYPTION, 2, 2, 'Encryption State'}, ;
   { ADS_DD_TABLE_DEFAULT_INDEX, Space(200), 200, 'Default Index'}, ;
   { ADS_DD_TABLE_IS_RI_PARENT, 2, 2, 'Is Referential Integrity Rule?'}, ;
   { ADS_DD_TABLE_AUTO_CREATE, 2, 2, 'Is Auto Created?'}, ;
   { ADS_DD_TABLE_PERMISSION_LEVEL, 2, 2, 'Table Permission Level'}, ;
   { ADS_DD_TABLE_MEMO_BLOCK_SIZE, 2, 2, 'Memo Block Size'} }

FOR i := 1 TO Len(aProperties)

   ASize(aProperties[i],7)
   nProperty := aProperties[i,1]
   xValue := aProperties[i,2]
   nLen := aProperties[i,3]

   nError := AdsDDGetTableProperty( nDictHandle, ;
      cTableName, ;
      nProperty, ;
      @xValue, ;
      @nLen )

   IF Valtype(xValue) = 'C'
      xValue := Strtran(xValue,Chr(0),'')
   ENDIF
   aProperties[i,5] := xValue
   aProperties[i,6] := nError
   aProperties[i,7] := AllTrim(DC_AdsGetLastError())
   AAdd(aData,xValue)
NEXT

RETURN aData


